unit day;
interface
uses maths87,
     SysUtils,Forms,Graphics;

const
     version:string ='E 1.3.2 ';
     birthday:string ='@EEK~QGGQ';

var
   {global variables}
   lun_month,new_moon,q1_moon,full_moon,q2_moon:array[0..19] of extended;
   new_moon_dt,q1_moon_dt,full_moon_dt,q2_moon_dt:array[0..19] of extended;
   weather,weather_dt:array[0..33] of extended;
   num_month:integer;
   name_month,no_day:array[0..17] of integer;
   name_leap,total_year:integer;
   year_default,tin_default,dey_default:integer;
   aphelion,perihelion,perihelion_dt,aphelion_dt:extended;
   lun_leap,new_leap,kc:boolean;
   ppp:boolean;
   defaultdir:string;

function _JD(YYYY,MM,DD:integer):extended;
procedure _invJD(dum:extended;var YYYY,MM,DD:integer);
procedure _invJDH(dum:extended;var y,m,d,h,mi:integer;var s:extended);
function _name_weather(i:integer):string;
function _name_month(i:integer):string;
function _tin(i:integer):string;
function _dey(i:integer):string;
function _dayofweek(x:extended):string;
function _name_day(i:integer):string;
function _nut_lambda(t:extended):extended;
function _sin(dum:extended):extended;
function _cos(dum:extended):extended;
function _ad_month(i:integer):string;
function dT(p:extended):extended;
function _R_sun(t:extended):extended;
function _phase(k,i:longint):extended;
function _lambda_sun(t:extended):extended;
function _sun_day(i,y:integer):extended;
procedure _create(year,time:integer;var peh,aph:extended;var leapyear:integer;preleap:integer);
function _str1(dum:integer):string;
function _val1(dum:string):integer;
function _easter(dum:integer):extended;
procedure deltemp;
procedure cal;

const
  DeltaTTable : array[0..185] of integer =
 (1240,1150,1060, 980, 910, 850, 790, 740, 700, 650,
   620, 580, 550, 530, 500, 480, 460, 440, 420, 400,
   370, 350, 330, 310, 280, 260, 240, 220, 200, 180,
   160, 140, 130, 120, 110, 100,  90,  90,  90,  90,
    90,  90,  90,  90, 100, 100, 100, 100, 100, 110,
   110, 110, 110, 110, 110, 110, 110, 120, 120, 120,
   120, 120, 130, 130, 130, 130, 140, 140, 140, 150,
   150, 150, 150, 160, 160, 160, 160, 160, 170, 170,
   170, 170, 170, 170, 170, 170, 160, 160, 150, 140,
   137, 131, 127, 125, 125, 125, 125, 125, 125, 123,
   120, 114, 106,  96,  86,  75,  66,  60,  57,  56,
    57,  59,  62,  65,  68,  71,  73,  75,  77,  78,
    79,  75,  64,  54,  29,  16, -10, -27, -36, -47
   -54, -52, -55, -56, -58, -59, -62, -64, -61, -47,
   -27,   0,  26,  54,  77, 105, 134, 160, 182, 202,
   212, 224, 235, 239, 243, 240, 239, 239, 237, 240,
   243, 253, 262, 273, 282, 291, 300, 307, 314, 322,
   331, 340, 350, 365, 383, 402, 422, 445, 465, 485,
   505, 522, 538, 549, 558, 569, 583);{, 592, 592, 602,
   611, 622, 632, 642);}

implementation
uses
    Unit1,unit2,unit10,unit11,unit13,unit8,unit9,unit19;

function _sin(dum:extended):extended;
begin
     _sin:=sin(rad(dum));
end;

function _cos(dum:extended):extended;
begin
     _cos:=cos(rad(dum));
end;

function _JD(YYYY,MM,DD:integer):extended;
var
   y,m,A,B:longint;
   waste:extended;
begin
     if MM>2 then
     begin
	  m:=MM;
	  y:=YYYY
     end
     else
     begin
	  y:=YYYY-1;
	  m:=MM+12
     end;
     if (YYYY>1582) or ((YYYY=1582) and (MM>10)) or ((YYYY=1582) and (MM=10) and (DD>=15)) then
     begin
	  A:=trunc(y/100);
	  B:=2-A+trunc(A/4)
     end
     else B:=0;
     if y<0 then waste:=trunc(365.25*y-0.75)+trunc(30.6001*(m+1))+DD+1720994.5+B
	else waste:=trunc(365.25*y)+trunc(30.6001*(m+1))+DD+1720994.5+B;
     _JD:=waste;
end;

procedure _invJD(dum:extended;var YYYY,MM,DD:integer);
var
   a,b,c,d,e,f:longint;
   g:extended;
begin
     a:=trunc(dum+0.5);
     g:=frac(dum+0.5);
     if a<2299161 then c:=a+1524
     else
     begin
	  b:=trunc((a-1867216.25)/36524.25);
	  c:=a+b-trunc(b/4)+1525
     end;
     d:=trunc((c-122.1)/365.25);
     e:=trunc(365.25*d);
     f:=trunc((c-e)/30.6001);
     DD:=trunc(c-e-int(30.6001*f)+g);
     MM:=f-1-12*trunc(f/14);
     YYYY:=d-4715-trunc((7+MM)/10)
end;

procedure _invJDH(dum:extended;var y,m,d,h,mi:integer;var s:extended);
var
   j,k:extended;
begin
     if frac(dum)=0.5 then
     begin
          j:=dum;
          k:=0;
     end
     else
     begin
          j:=round(dum)-0.5;
          k:=(dum-j)*24;
     end;
     dms(k,h,mi,s);
     _invJD(j,y,m,d);
end;

function _name_weather(i:integer):string;
var
   a:string;
begin
     if i>24 then i:=i-24;
     case i of
     1	 : a:='pH';
     2	 : a:='jH';
     3	 : a:='߬K';
     4	 : a:='B';
     5	 : a:='h';
     6	 : a:='K';
     7	 : a:='M';
     8	 : a:='\B';
     9	 : a:='߮L';
     10  : a:='p';
     11  : a:='~';
     12  : a:='L';
     13  : a:='p';
     14  : a:='j';
     15  : a:='߬';
     16  : a:='B';
     17  : a:='S';
     18  : a:='';
     19  : a:='HS';
     20  : a:='';
     21  : a:='ߥV';
     22  : a:='p';
     23  : a:='j';
     24  : a:='V';
     end;
     _name_weather:=a
end;

function _name_month(i:integer):string;
var
   a,b:string;
begin
     if i>100 then
     begin
          i:=i-100;
          b:='|'
     end
     else b:='  ';
     case i of
     1:   a:='  ';
     2:   a:='  G';
     3:   a:='  T';
     4:   a:='  |';
     5:   a:='  ';
     6:   a:='  ';
     7:   a:='  C';
     8:   a:='  K';
     9:   a:='  E';
     10:  a:='  Q';
     11:  a:='Q@';
     12:  a:='QG';
     end;
     _name_month:=b+a;
end;

function _ad_month(i:integer):string;
var
   a:string;
begin
     case i of
     1:   a:='  @';
     2:   a:='  G';
     3:   a:='  T';
     4:   a:='  |';
     5:   a:='  ';
     6:   a:='  ';
     7:   a:='  C';
     8:   a:='  K';
     9:   a:='  E';
     10:  a:='  Q';
     11:  a:='Q@';
     12:  a:='QG';
     end;
     _ad_month:=a;
end;

function _name_day(i:integer):string;
var
   a:string;
begin
     case i of
      1:    a:='@';
      2:    a:='G';
      3:    a:='T';
      4:    a:='|';
      5:    a:='줭';
      6:    a:='줻';
      7:    a:='C';
      8:    a:='K';
      9:    a:='E';
     10:    a:='Q';
     11:    a:='Q@';
     12:    a:='QG';
     13:    a:='QT';
     14:    a:='Q|';
     15:    a:='Q';
     16:    a:='Q';
     17:    a:='QC';
     18:    a:='QK';
     19:    a:='QE';
     20:    a:='GQ';
     21:    a:='ܤ@';
     22:    a:='ܤG';
     23:    a:='ܤT';
     24:    a:='ܥ|';
     25:    a:='ܤ';
     26:    a:='ܤ';
     27:    a:='ܤC';
     28:    a:='ܤK';
     29:    a:='ܤE';
     30:    a:='TQ';
     end;
     _name_day:=a
end;

function _tin(i:integer):string;
var
   a:string;
begin
     if i<0 then i:=i+10;
     if i>=10 then i:=i-10;
     case i of
      0:    a:='';
      1:    a:='A';
      2:    a:='';
      3:    a:='B';
      4:    a:='';
      5:    a:='v';
      6:    a:='';
      7:    a:='';
      8:    a:='';
      9:    a:='';
      end;
      _tin:=a;
end;

function _dey(i:integer):string;
var
   a:string;
begin
     if i<0 then i:=i+12;
     if i>=12 then i:=i-12;
     case i of
      0:    a:='l';
      1:    a:='';
      2:    a:='G';
      3:    a:='f';
      4:    a:='';
      5:    a:='x';
      6:    a:='';
      7:    a:='';
      8:    a:='';
      9:    a:='';
      10:   a:='';
      11:   a:='';
      end;
      _dey:=a;
end;

{ Find the weekday from Julian Day Number }
function _dayofweek(x:extended):string;
var
   i:longint;
   y:string;
begin
     i:=trunc(x+1.5) mod 7;
     case i of
     0:   y:='P';
     1:   y:='P@';
     2:   y:='PG';
     3:   y:='PT';
     4:   y:='P|';
     5:   y:='P';
     6:   y:='P';
     end;
     _dayofweek:=y;
end;

function _nut_lambda(t:extended):extended;
var
   _l,_lp,_F,_D,_O:extended;
   waste,dum:extended;
begin
     dum:=(t-2451545.0)/36525;
     waste:=485866.733+(1325*1296000.0+715922.633)*dum+31.310*sqr(dum)+0.064*dum*dum*dum;
     _l:=frac(waste/1296000.0)*360.0;
     waste:=1287099.804+(99*1296000.0+1292581.224)*dum-0.577*sqr(dum)-0.012*dum*dum*dum;
     _lp:=frac(waste/1296000.0)*360.0;
     waste:=335778.877+(1342*1296000.0+295263.137)*dum-13.257*sqr(dum)+0.011*dum*dum*dum;
     _F:=frac(waste/1296000.0)*360.0;
     waste:=1072261.307+(1236*1296000.0+1105601.328)*dum-6.891*sqr(dum)+0.019*dum*dum*dum;
     _D:=frac(waste/1296000.0)*360.0;
     waste:=450160.280-(5*1296000.0+482890.539)*dum+7.455*sqr(dum)+0.008*dum*dum*dum;
     _O:=frac(waste/1296000.0)*360.0;
     waste:=(-171996-174.2*dum)*1e-4*_sin( _O);
     waste:=waste+(2062+0.2*dum)*1e-4*_sin( 2*_O);
     waste:=waste+46e-4*_sin(-2*_l+2*_F+_O);
     waste:=waste+11e-4*_sin( 2*_l-2*_F);
     waste:=waste-3e-4*_sin(-2*_l+2*_F+2*_O);
     waste:=waste-3e-4*_sin( _l-_lp-_D);
     waste:=waste-2e-4*_sin(-2*_lp+2*_F-2*_D+_O);
     waste:=waste+1e-4*_sin( 2*_l-2*_F+_O);
     waste:=waste+(-13187-1.6*dum)*1e-4*_sin( 2*_F-2*_D+2*_O);
     waste:=waste+(1426-3.4*dum)*1e-4*_sin( _lp);
     waste:=waste+(-517+1.2*dum)*1e-4*_sin( _lp+2*_F-2*_D+2*_O);
     waste:=waste+(217-0.5*dum)*1e-4*_sin(-_lp+2*_F-2*_D+2*_O);
     waste:=waste+(129+0.1*dum)*1e-4*_sin( 2*_F-2*_D+_O);
     waste:=waste+48e-4*_sin( 2*_l-2*_D);
     waste:=waste-22e-4*_sin( 2*_F-2*_D);
     waste:=waste+(17-0.1*dum)*1e-4*_sin( 2*_lp);
     waste:=waste-15e-4*_sin( _lp+_O);
     waste:=waste+(-16+0.1*dum)*1e-4*_sin( 2*_lp+2*_F-2*_D+2*_O);
     waste:=waste-12e-4*_sin(-_lp+_O);
     waste:=waste-6e-4*_sin(-2*_l+2*_D+_O);
     waste:=waste-5e-4*_sin(-_lp+2*_F-2*_D+_O);
     waste:=waste+4e-4*_sin( 2*_l-2*_D+_O);
     waste:=waste+4e-4*_sin( _lp+2*_F-2*_D+_O);
     waste:=waste-4e-4*_sin( _l-_D);
     waste:=waste+1e-4*_sin( 2*_l+_lp-2*_D);
     waste:=waste+1e-4*_sin(-2*_F+2*_D+_O);
     waste:=waste-1e-4*_sin( _lp-2*_F+2*_D);
     waste:=waste+1e-4*_sin( _lp+2*_O);
     waste:=waste+1e-4*_sin(-_l+_D+_O);
     waste:=waste-1e-4*_sin( _lp+2*_F-2*_D);
     waste:=waste+(-2274-0.2*dum)*1e-4*_sin( 2*_F+2*_O);
     waste:=waste+(712+0.1*dum)*1e-4*_sin( _l);
     waste:=waste+(-386-0.4*dum)*1e-4*_sin( 2*_F+_O);
     waste:=waste-301e-4*_sin( _l+2*_F+2*_O);
     waste:=waste-158e-4*_sin( _l-2*_D);
     waste:=waste+123e-4*_sin(-_l+2*_F+2*_O);
     waste:=waste+63e-4*_sin( 2*_D);
     waste:=waste+(63+0.1*dum)*1e-4*_sin( _l+_O);
     waste:=waste+(-58-0.1*dum)*1e-4*_sin(-_l+_O);
     waste:=waste-59e-4*_sin(-_l+2*_F+2*_D+2*_O);
     waste:=waste-51e-4*_sin( _l+2*_F+_O);
     waste:=waste-38e-4*_sin( 2*_F+2*_D+2*_O);
     waste:=waste+29e-4*_sin( 2*_l);
     waste:=waste+29e-4*_sin( _l+2*_F-2*_D+2*_O);
     waste:=waste-31e-4*_sin( 2*_l+2*_F+2*_O);
     waste:=waste+26e-4*_sin( 2*_F);
     waste:=waste+21e-4*_sin(-_l+2*_F+_O);
     waste:=waste+16e-4*_sin(-_l+2*_D+_O);
     waste:=waste-13e-4*_sin( _l-2*_D+_O);
     waste:=waste-10e-4*_sin(-_l+2*_F+2*_D+_O);
     waste:=waste-7e-4*_sin( _l+_lp-2*_D);
     waste:=waste+7e-4*_sin( _lp+2*_F+2*_O);
     waste:=waste-7e-4*_sin(-_lp+2*_F+2*_O);
     waste:=waste-8e-4*_sin( _l+2*_F+2*_D+2*_O);
     waste:=waste+6e-4*_sin( _l+2*_D);
     waste:=waste+6e-4*_sin( 2*_l+2*_F-2*_D+2*_O);
     waste:=waste-6e-4*_sin( 2*_D+_O);
     waste:=waste-7e-4*_sin( 2*_F+2*_D+_O);
     waste:=waste+6e-4*_sin( _l+2*_F-2*_D+_O);
     waste:=waste-5e-4*_sin(-2*_D+_O);
     waste:=waste+5e-4*_sin( _l-_lp);
     waste:=waste-5e-4*_sin( 2*_l+2*_F+_O);
     waste:=waste-4e-4*_sin( _lp-2*_D);
     waste:=waste+4e-4*_sin( _l-2*_F);
     waste:=waste-4e-4*_sin( _D);
     waste:=waste-3e-4*_sin( _l+_lp);
     waste:=waste+3e-4*_sin( _l+2*_F);
     waste:=waste-3e-4*_sin( _l-_lp+2*_F+2*_O);
     waste:=waste-3e-4*_sin(-_l-_lp+2*_F+2*_D+2*_O);
     waste:=waste-2e-4*_sin(-2*_l+_O);
     waste:=waste-3e-4*_sin( 3*_l+2*_F+2*_O);
     waste:=waste-3e-4*_sin(-_lp+2*_F+2*_D+2*_O);
     waste:=waste+2e-4*_sin( _l+_lp+2*_F+2*_O);
     waste:=waste-2e-4*_sin(-_l+2*_F-2*_D+_O);
     waste:=waste+2e-4*_sin( 2*_l+_O);
     waste:=waste-2e-4*_sin( _l+2*_O);
     waste:=waste+2e-4*_sin( 3*_l);
     waste:=waste+2e-4*_sin( 2*_F+_D+2*_O);
     waste:=waste+1e-4*_sin(-_l+2*_O);
     waste:=waste-1e-4*_sin( _l-4*_D);
     waste:=waste+1e-4*_sin(-2*_l+2*_F+2*_D+2*_O);
     waste:=waste-2e-4*_sin(-_l+2*_F+4*_D+2*_O);
     waste:=waste-1e-4*_sin( 2*_l-4*_D);
     waste:=waste+1e-4*_sin( _l+_lp+2*_F-2*_D+2*_O);
     waste:=waste-1e-4*_sin( _l+2*_F+2*_D+_O);
     waste:=waste-1e-4*_sin(-2*_l+2*_F+4*_D+2*_O);
     waste:=waste+1e-4*_sin(-_l+4*_F+2*_O);
     waste:=waste+1e-4*_sin( _l-_lp-2*_D);
     waste:=waste+1e-4*_sin( 2*_l+2*_F-2*_D+_O);
     waste:=waste-1e-4*_sin( 2*_l+2*_F+2*_D+2*_O);
     waste:=waste-1e-4*_sin( _l+2*_D+_O);
     waste:=waste+1e-4*_sin( 4*_F-2*_D+2*_O);
     waste:=waste+1e-4*_sin( 3*_l+2*_F-2*_D+2*_O);
     waste:=waste-1e-4*_sin( _l+2*_F-2*_D);
     waste:=waste+1e-4*_sin( _lp+2*_F+_O);
     waste:=waste+1e-4*_sin(-_l-_lp+2*_D+_O);
     waste:=waste-1e-4*_sin(-2*_F+_O);
     waste:=waste-1e-4*_sin( 2*_F-_D+2*_O);
     waste:=waste-1e-4*_sin( _lp+2*_D);
     waste:=waste-1e-4*_sin( _l-2*_F-2*_D);
     waste:=waste-1e-4*_sin(-_lp+2*_F+_O);
     waste:=waste-1e-4*_sin( _l+_lp-2*_D+_O);
     waste:=waste-1e-4*_sin( _l-2*_F+2*_D);
     waste:=waste+1e-4*_sin( 2*_l+2*_D);
     waste:=waste-1e-4*_sin( 2*_F+4*_D+2*_O);
     waste:=waste+1e-4*_sin( _lp+_D);
     _nut_lambda:=waste;
end;

function dT(p:extended):extended;
var
  y,T,w : extended;
  Index : integer;
begin
     T:=(p-2451545.0)/36525;
     y := 2000.0 + T * 100.0;
     if (y > 2000) then w := 102.3 + T*(123.5 + T*32.5)
     else
         if (y < 1620) then
            if (y < 948) then w := 2715.6 + T*(573.36 + T*46.5)
               else w :=   50.6 + T*( 67.5 + T*22.5)
         else { Interpolate from the above table }
         begin
              Index := trunc((y - 1620)/2);
              if Index > 184 then Index := 184;
              y := y/2 - Index - 810;
              w := (DeltaTTable[Index] + (DeltaTTable[Index+1]-DeltaTTable[Index])*y) / 10;
         end;
         dT:=w/86400.0;
end;

{ Find the Julian Day of New Moon }
function _phase(k,i:longint):extended;
var
   JD:extended;
   T,E,M,MM,F,OMEGA,waste,W:extended;
   A:array[1..14] of extended;
   q:extended;
begin
     q:=k+i/4;
     T:=q/1236.85;
     E:=1-0.002516*T-7.4e-6*sqr(T);
     M:=rad(2.5534+29.10535669*q-2.18e-5*sqr(T)-1.1e-7*pow(T,3));
     MM:=rad(201.5643+385.81693528*q+0.0107438*sqr(T)+1.239e-5*pow(T,3)-5.8e-8*pow(T,4));
     F:=rad(160.7108+390.67050274*q-1.6341e-3*sqr(T)-2.27e-6*pow(T,3)+1.1e-8*pow(T,4));
     OMEGA:=rad(124.7746-1.56375580*q+2.0691e-3*sqr(T)+2.15e-6*pow(T,3));
     A[1]:=rad(299.77+0.107408*q-9.173e-3*sqr(T));
     A[2]:=rad(251.88+0.016321*q);
     A[3]:=rad(251.83+26.651886*q);
     A[4]:=rad(349.42+36.412478*q);
     A[5]:=rad(84.66+18.206239*q);
     A[6]:=rad(141.74+53.303771*q);
     A[7]:=rad(207.14+2.453732*q);
     A[8]:=rad(154.84+7.306860*q);
     A[9]:=rad(34.52+27.261239*q);
     A[10]:=rad(207.19+0.121824*q);
     A[11]:=rad(291.34+1.844379*q);
     A[12]:=rad(161.72+24.198154*q);
     A[13]:=rad(239.56+25.513099*q);
     A[14]:=rad(331.55+3.592518*q);
     if i=0 then
     begin
          waste:=-0.40720*sin(MM);
          waste:=waste+0.17241*E*sin(M);
          waste:=waste+0.01608*sin(2*MM);
          waste:=waste+0.01039*sin(2*F);
          waste:=waste+0.00739*E*sin(MM-M);
          waste:=waste-0.00514*E*sin(MM+M);
          waste:=waste+0.00208*sqr(E)*sin(2*M);
          waste:=waste-0.00111*sin(MM-2*F);
          waste:=waste-0.00057*sin(MM+2*F);
          waste:=waste+0.00056*E*sin(2*MM+M);
          waste:=waste-0.00042*sin(3*MM);
          waste:=waste+0.00042*E*sin(M+2*F);
          waste:=waste+0.00038*E*sin(M-2*F);
          waste:=waste-0.00024*E*sin(2*MM-M);
          waste:=waste-0.00017*sin(OMEGA);
          waste:=waste-0.00007*sin(MM+2*M);
          waste:=waste+0.00004*sin(2*MM-2*F);
          waste:=waste+0.00004*sin(3*M);
          waste:=waste+0.00003*sin(MM+M-2*F);
          waste:=waste+0.00003*sin(2*MM+2*F);
          waste:=waste-0.00003*sin(MM+M+2*F);
          waste:=waste+0.00003*sin(MM-M+2*F);
          waste:=waste-0.00002*sin(MM-M-2*F);
          waste:=waste-0.00002*sin(3*MM+M);
          waste:=waste+0.00002*sin(4*MM);
     end
     else
     if i=2 then
     begin
          waste:=-0.40614*sin(MM);
          waste:=waste+0.17302*E*sin(M);
          waste:=waste+0.01614*sin(2*MM);
          waste:=waste+0.01043*sin(2*F);
          waste:=waste+0.00734*E*sin(MM-M);
          waste:=waste-0.00515*E*sin(MM+M);
          waste:=waste+0.00209*sqr(E)*sin(2*M);
          waste:=waste-0.00111*sin(MM-2*F);
          waste:=waste-0.00057*sin(MM+2*F);
          waste:=waste+0.00056*E*sin(2*MM+M);
          waste:=waste-0.00042*sin(3*MM);
          waste:=waste+0.00042*E*sin(M+2*F);
          waste:=waste+0.00038*E*sin(M-2*F);
          waste:=waste-0.00024*E*sin(2*MM-M);
          waste:=waste-0.00017*sin(OMEGA);
          waste:=waste-0.00007*sin(MM+2*M);
          waste:=waste+0.00004*sin(2*MM-2*F);
          waste:=waste+0.00004*sin(3*M);
          waste:=waste+0.00003*sin(MM+M-2*F);
          waste:=waste+0.00003*sin(2*MM+2*F);
          waste:=waste-0.00003*sin(MM+M+2*F);
          waste:=waste+0.00003*sin(MM-M+2*F);
          waste:=waste-0.00002*sin(MM-M-2*F);
          waste:=waste-0.00002*sin(3*MM+M);
          waste:=waste+0.00002*sin(4*MM);
     end
     else
     begin
          waste:=-0.62801*sin(MM);
          waste:=waste+0.17172*E*sin(M);
          waste:=waste-0.01183*E*sin(MM+M);
          waste:=waste+0.00862*sin(2*MM);
          waste:=waste+0.00804*sin(2*F);
          waste:=waste+0.00454*sin(MM-M);
          waste:=waste+0.00204*sin(2*M);
          waste:=waste-0.00180*sin(MM-2*F);
          waste:=waste-0.00070*sin(MM+2*F);
          waste:=waste-0.00040*sin(3*MM);
          waste:=waste-0.00034*E*sin(2*MM-M);
          waste:=waste+0.00032*E*sin(M+2*F);
          waste:=waste+0.00032*E*sin(M-2*F);
          waste:=waste-0.00028*sqr(E)*sin(MM+2*M);
          waste:=waste+0.00027*E*sin(2*MM+M);
          waste:=waste-0.00017*sin(OMEGA);
          waste:=waste-0.00005*sin(MM-M-2*F);
          waste:=waste+0.00004*sin(2*MM+2*F);
          waste:=waste-0.00004*sin(MM+M+2*F);
          waste:=waste+0.00004*sin(MM-2*M);
          waste:=waste+0.00003*sin(MM+M-2*F);
          waste:=waste+0.00003*sin(3*M);
          waste:=waste+0.00002*sin(2*MM-2*F);
          waste:=waste+0.00002*sin(MM-M+2*F);
          waste:=waste-0.00002*sin(3*MM+M);
          W:=0.00306-0.00038*E*cos(M)+0.00026*cos(MM);
          W:=W-0.00002*cos(MM-M)+0.00002*cos(MM+M)+0.00002*cos(2*F);
          if i=1 then waste:=waste+W
             else waste:=waste-W;
     end;
     waste:=waste+3.25e-4*sin(A[1]);
     waste:=waste+1.65e-4*sin(A[2]);
     waste:=waste+1.64e-4*sin(A[3]);
     waste:=waste+1.26e-4*sin(A[4]);
     waste:=waste+1.10e-4*sin(A[5]);
     waste:=waste+0.62e-4*sin(A[6]);
     waste:=waste+0.60e-4*sin(A[7]);
     waste:=waste+0.56e-4*sin(A[8]);
     waste:=waste+0.47e-4*sin(A[9]);
     waste:=waste+0.42e-4*sin(A[10]);
     waste:=waste+0.40e-4*sin(A[11]);
     waste:=waste+0.37e-4*sin(A[12]);
     waste:=waste+0.35e-4*sin(A[13]);
     waste:=waste+0.23e-4*sin(A[14]);
     JD:=2451550.09765+29.530588853*q+1.337e-4*sqr(T)-1.50e-7*pow(T,3)+7.3e-10*pow(T,4);
     _phase:=JD+waste;
end;

{ Find the Radius Vector of Sun }
function _R_sun(t:extended):extended;
var
   R0,R1,R2,R3,R4,U:extended;
begin
     U:=(t-2451545.0)/365250;
     R0:=100013989;
     R0:=R0+1670700*cos(3.0984635+U*6283.07585);
     R0:=R0+13956*cos(3.05525+U*12566.15170);
     R0:=R0+3084*cos(5.1985+U*77713.7715);
     R0:=R0+1628*cos(1.1739+U*5753.3849);
     R0:=R0+1576*cos(2.8469+U*7860.4194);
     R0:=R0+925*cos(5.453+U*11506.770);
     R0:=R0+542*cos(4.564+U*3930.210);
     R0:=R0+472*cos(3.661+U*5884.927);
     R0:=R0+346*cos(0.964+U*5507.553);
     R0:=R0+329*cos(5.900+U*5223.694);
     R0:=R0+307*cos(0.299+U*5573.143);
     R0:=R0+243*cos(4.273+U*11790.629);
     R0:=R0+212*cos(5.847+U*1577.344);
     R0:=R0+186*cos(5.022+U*10977.079);
     R0:=R0+175*cos(3.012+U*18849.228);
     R0:=R0+110*cos(5.055+U*5486.778);
     R0:=R0+98*cos(0.89+U*6069.78);
     R0:=R0+86*cos(5.69+U*15720.84);
     R0:=R0+86*cos(1.27+U*161000.69);
     R0:=R0+65*cos(0.27+U*17260.15);
     R0:=R0+63*cos(0.92+U*529.69);
     R0:=R0+57*cos(2.01+U*83996.85);
     R0:=R0+56*cos(5.24+U*71430.70);
     R0:=R0+49*cos(3.25+U*2544.31);
     R0:=R0+47*cos(2.58+U*775.52);
     R0:=R0+45*cos(5.54+U*9437.76);
     R0:=R0+43*cos(6.01+U*6275.96);
     R0:=R0+39*cos(5.36+U*4694.00);
     R0:=R0+38*cos(2.39+U*8827.39);
     R0:=R0+37*cos(0.83+U*19651.05);
     R0:=R0+37*cos(4.90+U*12139.55);
     R0:=R0+36*cos(1.67+U*12036.46);
     R0:=R0+35*cos(1.84+U*2942.46);
     R0:=R0+33*cos(0.24+U*7084.90);
     R0:=R0+32*cos(0.18+U*5088.63);
     R0:=R0+32*cos(1.78+U*398.15);
     R0:=R0+28*cos(1.21+U*6286.60);
     R0:=R0+28*cos(1.90+U*6279.55);
     R0:=R0+26*cos(4.59+U*10447.39);
     R1:=103019*cos(1.107490+U*6283.075850);
     R1:=R1+1721*cos(1.0644+U*12566.1517);
     R1:=R1+702*cos(3.142);
     R1:=R1+32*cos(1.02+U*18849.23);
     R1:=R1+31*cos(2.84+U*5507.55);
     R1:=R1+25*cos(1.32+U*5223.69);
     R1:=R1+18*cos(1.42+U*1577.34);
     R1:=R1+10*cos(5.91+U*10977.08);
     R1:=R1+9*cos(1.42+U*6275.96);
     R1:=R1+9*cos(0.27+U*5486.78);
     R2:=4359*cos(5.7846+U*6283.0758);
     R2:=R2+124*cos(5.579+U*12566.152);
     R2:=R2+12*cos(3.14);
     R2:=R2+9*cos(3.63+U*77713.77);
     R2:=R2+6*cos(1.87+U*5573.14);
     R2:=R2+3*cos(5.47+U*18849.23);
     R3:=145*cos(4.273+U*6283.076);
     R3:=R3+7*cos(3.92+U*12566.15);
     R4:=4*cos(2.56+U*6283.08);
     _R_sun:=(R0+R1*U+R2*sqr(U)+R3*pow(U,3)+R4*pow(U,4))*1e-8;
end;

{ Find the Apparent Geocentric Longitude of Sun }
function _lambda_sun(t:extended):extended;
var
   U,L0,L1,L2,L3,L4,L5,waste:extended;
begin
     U:=(t-2451545.0)/365250.0;
     L0:=175347046;
     L0:=L0+3341656*cos(4.6692568+U*6283.07585);
     L0:=L0+34894*cos(4.62610+U*12566.15170);
     L0:=L0+3497*cos(2.7441+U*5753.3849);
     L0:=L0+3418*cos(2.8289+U*3.5231);
     L0:=L0+3136*cos(3.6277+U*77713.7715);
     L0:=L0+2676*cos(4.4181+U*7860.4194);
     L0:=L0+2343*cos(6.1352+U*3930.2097);
     L0:=L0+1324*cos(0.7425+U*11506.7698);
     L0:=L0+1273*cos(2.0371+U*529.6910);
     L0:=L0+1199*cos(1.1096+U*1577.3435);
     L0:=L0+990*cos(5.233+U*5884.927);
     L0:=L0+902*cos(2.045+U*26.298);
     L0:=L0+857*cos(3.508+U*398.149);
     L0:=L0+780*cos(1.179+U*5223.694);
     L0:=L0+753*cos(2.533+U*5507.553);
     L0:=L0+505*cos(4.583+U*18849.228);
     L0:=L0+493*cos(4.205+U*775.523);
     L0:=L0+357*cos(2.920+U*0.067);
     L0:=L0+317*cos(5.849+U*11790.629);
     L0:=L0+284*cos(1.899+U*796.298);
     L0:=L0+271*cos(0.315+U*10977.079);
     L0:=L0+243*cos(0.345+U*5486.778);
     L0:=L0+206*cos(4.806+U*2544.314);
     L0:=L0+205*cos(1.869+U*5573.143);
     L0:=L0+202*cos(2.458+U*6069.777);
     L0:=L0+156*cos(0.833+U*213.299);
     L0:=L0+132*cos(3.411+U*2942.463);
     L0:=L0+126*cos(1.083+U*20.775);
     L0:=L0+115*cos(0.645+U*0.980);
     L0:=L0+103*cos(0.636+U*4694.003);
     L0:=L0+102*cos(0.976+U*15720.839);
     L0:=L0+102*cos(4.267+U*7.114);
     L0:=L0+99*cos(6.21+U*2146.17);
     L0:=L0+98*cos(0.68+U*155.42);
     L0:=L0+86*cos(5.98+U*161000.69);
     L0:=L0+85*cos(1.30+U*6275.96);
     L0:=L0+85*cos(3.67+U*71430.70);
     L0:=L0+80*cos(1.81+U*17260.15);
     L0:=L0+79*cos(3.04+U*12036.46);
     L0:=L0+75*cos(1.76+U*5088.63);
     L0:=L0+74*cos(3.50+U*3154.69);
     L0:=L0+74*cos(4.68+U*801.82);
     L0:=L0+70*cos(0.83+U*9437.76);
     L0:=L0+62*cos(3.98+U*8827.39);
     L0:=L0+61*cos(1.82+U*7084.90);
     L0:=L0+57*cos(2.78+U*6286.60);
     L0:=L0+56*cos(4.39+U*14143.50);
     L0:=L0+56*cos(3.47+U*6279.55);
     L0:=L0+52*cos(0.19+U*12139.55);
     L0:=L0+52*cos(1.33+U*1748.02);
     L0:=L0+51*cos(0.28+U*5856.48);
     L0:=L0+49*cos(0.49+U*1194.45);
     L0:=L0+41*cos(5.37+U*8429.24);
     L0:=L0+41*cos(2.40+U*19651.05);
     L0:=L0+39*cos(6.17+U*10447.39);
     L0:=L0+37*cos(6.04+U*10213.29);
     L0:=L0+37*cos(2.57+U*1059.38);
     L0:=L0+36*cos(1.71+U*2352.87);
     L0:=L0+36*cos(1.78+U*6812.77);
     L0:=L0+33*cos(0.59+U*17789.85);
     L0:=L0+30*cos(0.44+U*83996.85);
     L0:=L0+30*cos(2.74+U*1349.87);
     L0:=L0+25*cos(3.16+U*4690.48);
     L1:=628331966.747e3;
     L1:=L1+206059*cos(2.678235+U*6283.075850);
     L1:=L1+4303*cos(2.6351+U*12566.1517);
     L1:=L1+425*cos(1.590+U*3.523);
     L1:=L1+119*cos(5.796+U*26.298);
     L1:=L1+109*cos(2.966+U*1577.344);
     L1:=L1+93*cos(2.59+U*18849.23);
     L1:=L1+72*cos(1.14+U*529.69);
     L1:=L1+68*cos(1.87+U*398.15);
     L1:=L1+67*cos(4.41+U*5507.55);
     L1:=L1+59*cos(2.89+U*5223.69);
     L1:=L1+56*cos(2.17+U*155.42);
     L1:=L1+45*cos(0.40+U*796.30);
     L1:=L1+36*cos(0.47+U*775.52);
     L1:=L1+29*cos(2.65+U*7.11);
     L1:=L1+21*cos(5.34+U*0.98);
     L1:=L1+19*cos(1.85+U*5486.78);
     L1:=L1+19*cos(4.97+U*213.30);
     L1:=L1+17*cos(2.99+U*6275.96);
     L1:=L1+16*cos(0.03+U*2544.31);
     L1:=L1+16*cos(1.43+U*2146.17);
     L1:=L1+15*cos(1.21+U*10977.08);
     L1:=L1+12*cos(2.83+U*1748.02);
     L1:=L1+12*cos(3.26+U*5088.63);
     L1:=L1+12*cos(5.27+U*1194.45);
     L1:=L1+12*cos(2.08+U*4694.00);
     L1:=L1+11*cos(0.77+U*553.57);
     L1:=L1+10*cos(1.30+U*6286.60);
     L1:=L1+10*cos(4.24+U*1349.87);
     L1:=L1+9*cos(2.70+U*242.73);
     L1:=L1+9*cos(5.64+U*951.72);
     L1:=L1+8*cos(5.30+U*2352.87);
     L1:=L1+6*cos(2.65+U*9437.76);
     L1:=L1+6*cos(4.67+U*4690.48);
     L2:=52919;
     L2:=L2+8720*cos(1.0721+U*6283.0758);
     L2:=L2+309*cos(0.867+U*12566.152);
     L2:=L2+27*cos(0.05+U*3.52);
     L2:=L2+16*cos(5.19+U*26.30);
     L2:=L2+16*cos(3.68+U*155.42);
     L2:=L2+10*cos(0.76+U*18849.23);
     L2:=L2+9*cos(2.06+U*77713.77);
     L2:=L2+7*cos(0.83+U*775.52 );
     L2:=L2+5*cos(4.66+U*1577.34);
     L2:=L2+4*cos(1.03+U*7.11);
     L2:=L2+4*cos(3.44+U*5573.14);
     L2:=L2+3*cos(5.14+U*796.30);
     L2:=L2+3*cos(6.05+U*5507.55);
     L2:=L2+3*cos(1.19+U*242.73);
     L2:=L2+3*cos(6.12+U*529.69);
     L2:=L2+3*cos(0.31+U*398.15);
     L2:=L2+3*cos(2.28+U*553.57);
     L2:=L2+2*cos(4.38+U*5223.69);
     L2:=L2+2*cos(3.75+U*0.98);
     L3:=289*cos(5.844+U*6283.076);
     L3:=L3+35;
     L3:=L3+17*cos(5.49+U*12566.15);
     L3:=L3+3*cos(5.20+U*155.42);
     L3:=L3+cos(4.72+U*3.52);
     L3:=L3+cos(5.30+U*18849.23);
     L3:=L3+cos(5.97+U*242.73);
     L4:=114*cos(3.142);
     L4:=L4+8*cos(4.13+U*6283.08);
     L4:=L4+cos(3.84+U*12566.15);
     L5:=cos(3.14);
     waste:=(L0+L1*U+L2*sqr(U)+L3*pow(U,3)+L4*pow(U,4)+L5*pow(U,5))*1e-8+pi;
     waste:=waste+rad(_nut_lambda(t)/3600);
     waste:=waste-rad(20.4898/3600)/_R_sun(t);
     waste:=deg(waste);
     while waste<1e-7 do waste:=waste+360.0;
     _lambda_sun:=waste
end;

function _sun_day(i,y:integer):extended;
var
   f0,w0:extended;
   t:extended;
begin
     if i<=6 then t:=285+(i-1)*15 else t:=(i-6)*15;
     f0:=_JD(y,round(i/2),1);
     w0:=_lambda_sun(f0);
     repeat
           f0:=f0+58*_sin(t-w0);
           w0:=_lambda_sun(f0);
     until abs(w0-t)<1e-7;
     _sun_day:=f0
end;

procedure _create(year,time:integer;var peh,aph:extended;var leapyear:integer;preleap:integer);
var
   i,j:integer;
   q:extended;
   k:longint;
   y,m,d:integer;
   fixm,fixw:integer;
   tri,leap,leaped:boolean;
   A1,A2,A3,A4,A5:extended;
   dum:integer;
   w_d:array[0..33] of extended;
   waste:extended;

begin
     { finding new moons }
     leapyear:=0;
     k:=round((year-2000)*12.3685)+1;
     repeat
           k:=k-1;
           waste:=_phase(k,0);
           q:=round(waste+8/24-dT(waste))-0.5;
     until q<_JD(year,1,1);
     { the new moon just before the year }
     new_moon_dt[0]:=_phase(k,0);
     new_moon[0]:=new_moon_dt[0]+8/24-dT(waste);
     lun_month[0]:=round(new_moon[0])-0.5;
     q1_moon_dt[0]:=_phase(k,1);
     q1_moon[0]:=q1_moon_dt[0]+8/24-dT(waste);
     full_moon_dt[0]:=_phase(k,2);
     full_moon[0]:=full_moon_dt[0]+8/24-dT(waste);
     q2_moon_dt[0]:=_phase(k,3);
     q2_moon[0]:=q2_moon_dt[0]+8/24-dT(waste);
     { the new moons within the year }
     i:=0;
     repeat
           k:=k+1;
           i:=i+1;
           new_moon_dt[i]:=_phase(k,0);
           new_moon[i]:=new_moon_dt[i]+8/24-dT(waste);
           lun_month[i]:=round(new_moon[i])-0.5;
           q1_moon_dt[i]:=_phase(k,1);
           q1_moon[i]:=q1_moon_dt[i]+8/24-dT(waste);
           full_moon_dt[i]:=_phase(k,2);
           full_moon[i]:=full_moon_dt[i]+8/24-dT(waste);
           q2_moon_dt[i]:=_phase(k,3);
           q2_moon[i]:=q2_moon_dt[i]+8/24-dT(waste);
     until lun_month[i]>=_JD(year+1,1,1);
     { the new moon just after the year }
     for j:=1 to 3 do
     begin
          new_moon_dt[i+j]:=_phase(k+j,0);
          new_moon[i+j]:=new_moon_dt[i+j]+8/24-dT(waste);
          q1_moon_dt[i+j]:=_phase(k+j,1);
          q1_moon[i+j]:=q1_moon_dt[i+j]+8/24-dT(waste);
          full_moon_dt[i+j]:=_phase(k+j,2);
          full_moon[i+j]:=full_moon_dt[i+j]+8/24-dT(waste);
          q2_moon_dt[i+j]:=_phase(k+j,3);
          q2_moon[i+j]:=q2_moon_dt[i+j]+8/24-dT(waste);
          lun_month[i+j]:=round(new_moon[i+j])-0.5;
     end;
     num_month:=i+2;
{     for i:=0 to num_month do
         if (year<=1911) and ((new_moon[i]-lun_month[i])*24>=23.0) then lun_month[i]:=lun_month[i]+1;}
     { finding weathers }
     for i:=0 to 32 do
     begin
          if i=0 then
          begin
               weather_dt[0]:=_sun_day(24,year-1);
               weather[0]:=weather_dt[0]+8/24-dT(waste)
          end
             else if i>=25 then
             begin
                  weather_dt[i]:=_sun_day(i-24,year+1);
                  weather[i]:=weather_dt[i]+8/24-dT(waste)
             end
                  else
                  begin
                       weather_dt[i]:=_sun_day(i,year);
                       weather[i]:=weather_dt[i]+8/24-dT(waste);
                  end;
          w_d[i]:=round(weather[i])-0.5;
          wait.Gauge.Progress:=round((i+time*32)/64*100);
     end;
     { finding perihelion and aphelion }
     dum:=year;
     tri:=false;
     repeat
           aph:=round(0.99997*(dum-2000.01))+0.5;
           A1:=328.41+132.788585*aph;
           A2:=316.13+584.903153*aph;
           A3:=346.20+450.380738*aph;
           A4:=136.95+659.306737*aph;
           A5:=249.52+329.653368*aph;
           aph:=2451547.507+365.2596358*aph+1.58e-8*sqr(aph);
           aphelion_dt:=aph-1.352*_sin(A1)+0.061*_sin(A2)+0.062*_sin(A3)+0.029*_sin(A4)+0.031*_sin(A5);
           aph:=round(aphelion_dt+8/24-dT(aphelion_dt))-0.5;
           if aph<_JD(year,1,1) then
           begin
                dum:=dum+1;
                tri:=true;
           end;
           if aph>_JD(year,12,31) then
           begin
                dum:=dum-1;
                tri:=true;
           end;
     until ((aph>=_JD(year,1,1)) and (aph<=_JD(year,12,31))) or tri;
     dum:=year;
     tri:=false;
     repeat
           peh:=round(0.99997*(dum-2000.01));
           A1:=328.41+132.788585*peh;
           A2:=316.13+584.903153*peh;
           A3:=346.20+450.380738*peh;
           A4:=136.95+659.306737*peh;
           A5:=249.52+329.653368*peh;
           peh:=2451547.507+365.2596358*peh+1.58e-8*sqr(peh);
           perihelion_dt:=peh+1.278*_sin(A1)-0.055*_sin(A2)-0.091*_sin(A3)-0.056*_sin(A4)-0.045*_sin(A5);
           peh:=round(perihelion_dt+8/24-dT(perihelion_dt))-0.5;
           if peh<_JD(year,1,1) then
           begin
                dum:=dum+1;
                tri:=true;
           end;
           if peh>_JD(year,12,31) then
           begin
                dum:=dum-1;
                tri:=true;
           end;
     until ((peh>=_JD(year,1,1)) and (peh<=_JD(year,12,31))) or tri;
     i:=-1;
     repeat
           i:=i+1;
     until abs(aph-w_d[2*i])<30;
     fixw:=i;
     if fixw>11 then fixw:=fixw-12;
     j:=-1;
     repeat
           j:=j+1;
     until (lun_month[j]<=w_d[2*fixw]) and (lun_month[j+1]>w_d[2*fixw]);
     fixm:=j;
     name_month[fixm]:=fixw-1;
     if name_month[fixm]>12 then name_month[fixm]:=name_month[fixm]-12;
     if name_month[fixm]<=0 then name_month[fixm]:=name_month[fixm]+12;
     i:=0;
     leaped:=false;
     repeat
           i:=i+1;
           j:=fixm-i;
           if name_month[j+1]>100 then name_month[j]:=name_month[j+1]-100
              else name_month[j]:=name_month[j+1]-1;
           if name_month[j]>12 then name_month[j]:=name_month[j]-12;
           if name_month[j]<1 then name_month[j]:=name_month[j]+12;
           if (j<5) and (name_month[j]>10) then leap:=preleap=name_month[j] else leap:=false;
           if (leap and not leaped) or (w_d[2*(fixw-i)]<lun_month[j])
              and (leapyear=0) and (preleap=0) then
           begin
                name_month[j]:=name_month[j]+100;
                leapyear:=name_month[j]-100;
                leaped:=true;
           end;
     until i=fixm;
     i:=0;
     repeat
           i:=i+1;
           j:=fixm+i;
           name_month[j]:=name_month[j-1] mod 100+1;
           if name_month[j]>12 then name_month[j]:=name_month[j]-12;
           if name_month[j]<1 then name_month[j]:=name_month[j]+12;
           if (w_d[2*(fixw+i)]>=lun_month[j+1]) and (leapyear=0) and (preleap=0) then
           begin
                name_month[j]:=name_month[j-1]+100;
                leapyear:=name_month[j-1];
                leaped:=true;
           end;
     until i+fixm=num_month;
     leapyear:=0;
     for i:=0 to num_month do no_day[i]:=round(lun_month[i+1]-lun_month[i]);
     k:=-1;
     repeat
           k:=k+1
     until name_month[k]=1;
     j:=num_month+1;
     repeat
           j:=j-1;
     until (name_month[j]=112) or ((name_month[j]=12) and (name_month[j+1]=1));
     total_year:=0;
     for i:=k to j do
     begin
          total_year:=total_year+no_day[i];
          if name_month[i]>100 then leapyear:=name_month[i]-100;
     end;
end;

function _str1(dum:integer):string;
var
   k:string;
begin
     str(dum,k);
     _str1:=k;
end;

function _val1(dum:string):integer;
var
   k,k1:integer;
begin
     val(dum,k,k1);
     _val1:=k;
end;

function _easter(dum:integer):extended;
var
   a,b,c,d,e,f,g,h,i,k,l,m,n,p,x:integer;
   mm,dd:integer;
begin
     x:=dum;
     a:=x mod 19;
     b:=x div 100;
     c:=x mod 100;
     d:=b div 4;
     e:=b mod 4;
     f:=(b+8) div 25;
     g:=(b-f+1) div 3;
     h:=(19*a+b-d-g+15) mod 30;
     i:=c div 4;
     k:=c mod 4;
     l:=(32+2*e+2*i-h-k) mod 7;
     m:=(a+11*h+22*l) div 451;
     n:=(h+l-7*m+114) div 31;
     p:=(h+l-7*m+114) mod 31;
     dd:=p+1;
     mm:=n;
     _easter:=_JD(x,mm,dd)
end;

procedure deltemp;
var
   i:integer;
   s:string;
begin
     s:=defaultdir+'~c2.tmp';
     deletefile(s);
     s:=defaultdir+'~c.tmp';
     deletefile(s);
     s:=defaultdir+'~h.tmp';
     deletefile(s);
     s:=defaultdir+'~w.tmp';
     deletefile(s);
     s:=defaultdir+'~p.tmp';
     deletefile(s);
     for i:=1 to 12 do
     begin
          s:=defaultdir+'~m'+_str1(i)+'.tmp';
          deletefile(s);
          s:=defaultdir+'~l'+_str1(i)+'.tmp';
          deletefile(s);
     end;
     s:=defaultdir+'~l'+_str1(name_leap+100)+'.tmp';
     deletefile(s);
end;

procedure cal;
var
   k1,i,j,k,l,count:integer;
   s,fname:string;
   y,m,d,h,mi:integer;
   yy,mm,dd,noday,startdd:integer;
   sec,w:extended;
   f:textfile;
   leap,found:boolean;
   StartJD,JD:extended;
   count1:integer;

procedure showdt(p:extended;j:integer);
var
   h,JD:extended;
   YY,MM,DD:integer;
   hr,min:integer;
   sec:extended;
begin
     _invJDH(p,YY,MM,DD,hr,min,sec);
     write(f,DD:2,'/',MM:2,'/',YY MOD 100:2,' ',hr:2,':',min:2,' ');
     JD:=_JD(YY,MM,DD);
     write(f,_name_day(round(JD-lun_month[j])+1));
     write(f,'|');
end;

begin
     // wait.show;
     _create(year_default-1,0,perihelion,aphelion,i,0);
     _create(year_default,1,perihelion,aphelion,name_leap,i);
     if year_default=-103 then FirstMenu._minus.enabled:=false
        else FirstMenu._minus.enabled:=true;
     if year_default=4000 then FirstMenu._next.enabled:=false
        else FirstMenu._next.enabled:=true;
     if name_leap<>0 then count1:=30 else count1:=29;
     count:=0;

     {Layout of FirstMenu}
     new_leap:=false;
     if year_default<=1582 then
        if year_default mod 4=0 then new_leap:=true;
     if year_default>1582 then
        if (year_default mod 4=0) and (year_default mod 100<>0) then new_leap:=true
            else if year_default mod 400=0 then new_leap:=true;
     tin_default:=(year_default-1984) mod 10;
     dey_default:=(year_default-1984) mod 12;
     if year_default<=0 then s:='e '+_str1(abs(year_default-1))+' ~'
        else s:=' '+_str1(year_default)+' ~';
     FirstMenu.syear.caption:=s;
     s:='A'+_tin(tin_default)+_dey(dey_default)+'~';
     FirstMenu.lyear.caption:=s;
     {display no. of days in solar year}
     if new_leap then
     begin
          FirstMenu.lorf1.font.color:=clFuchsia;
          FirstMenu.lorf1.caption:=']|~^';
          FirstMenu.sno.caption:='366 .'
     end
     else
     begin
          FirstMenu.lorf1.font.color:=cllime;
          FirstMenu.lorf1.caption:=']~^';
          FirstMenu.sno.caption:='365 .'
     end;
     {display no. of days in lunar year}
     if total_year<360 then
     begin
          FirstMenu.lorf2.Font.color:=claqua;
          FirstMenu.lorf2.caption:=']~^';
     end
     else
     begin
          FirstMenu.lorf2.font.color:=clred;
          FirstMenu.lorf2.caption:=']|~^';
     end;
     FirstMenu.lno.caption:=_str1(total_year)+' .';
     {display perihelion and aphelion}
     _invJD(perihelion,y,m,d);
     FirstMenu.perihelion.caption:=_str1(d)+'/'+_str1(m);
     _invJD(aphelion,y,m,d);
     FirstMenu.aphelion.caption:=_str1(d)+'/'+_str1(m);
     {display dt}
     dms(dT(_JD(year_default,7,1))*24,h,mi,sec);
     FirstMenu.delt.caption:=_str1(h)+'  '+_str1(mi)+'  '+_str1(trunc(sec))+' ';
     fname:=defaultdir+'~c.tmp';
     assignfile(f,fname);
     rewrite(f);
     for i:=0 to num_month do
     begin
          s:='';
          _invJD(lun_month[i],y,m,d);
          if name_month[i]>100 then lun_leap:=true else lun_leap:=false;
          write(f,_name_month(name_month[i]));
          if no_day[i]=29 then write(f,'p') else write(f,'j');
          write(f,' @:');
          writeln(f,d:2,'/',m:2,'/',y:4,' ',_dayofweek(lun_month[i]));
     end;
     closefile(f);
     FirstMenu.Memo.Lines.LoadfromFile(fname);
     count:=count+1;
     wait.gauge1.progress:=round(count/count1*100);

     {Layout of Outweather}
     fname:=defaultdir+'~w.tmp';
     assignfile(f,fname);
     rewrite(f);
     writeln(f);
     write(f,'':29,'');
     if year_default<=0 then write(f,'e ',abs(year_default-1)) else write(f,' ',year_default);
     writeln(f,' ~ (',_tin(tin_default),_dey(dey_default),'~)');
     writeln(f);
     write(f,'+');
     for i:=1 to 38 do write(f,'-');
     write(f,'+');
     for i:=1 to 38 do write(f,'-');
     writeln(f,'+');
     writeln(f,'|','':17,'`','':17,'|','':17,'','':17,'|');
     write(f,'+');
     for i:=1 to 38 do write(f,'-');
     write(f,'+');
     for i:=1 to 38 do write(f,'-');
     writeln(f,'+');
     for j:=1 to 14 do
     begin
          for k:=0 to 1 do
          begin
               l:=2*j-1+k;
               _invJDH(weather[l],y,mm,dd,h,mi,sec);
               write(f,'|',_name_weather(l),':',dd:2,'/',mm:2,' ',h:2,':',mi:2,' ');
               write(f,copy(_dayofweek(round(weather[l]-0.5)),5,2),' ');
               i:=0;
               found:=false;
               leap:=false;
               repeat
                     if lun_month[i]>round(weather[l])-0.5 then
                     begin
                          d:=trunc(round(weather[l])-0.5)-trunc(lun_month[i-1])+1;
                          found:=true;
                          m:=name_month[i-1];
                     end;
                     i:=i+1
               until found or (i>num_month);
               if m>100 then leap:=true;
               if (y>year_default) and (m mod 100<=3) then
               begin
                    write(f,_tin(tin_default+1),_dey(dey_default+1))
               end
                  else if y>year_default then
                       begin
                            write(f,_tin(tin_default),_dey(dey_default))
                       end
                       else if (y<year_default) or ((m mod 100>=10) and (mm<3)) then
                            begin
                                 write(f,_tin(tin_default-1),_dey(dey_default-1))
                            end
                            else
                            begin
                                 write(f,_tin(tin_default),_dey(dey_default))
                            end;
               write(f,'~');
               write(f,_name_month(m),_name_day(d));
               if k=1 then writeln(f,'|');
          end;
     end;
     write(f,'+');
     for i:=1 to 38 do write(f,'-');
     write(f,'+');
     for i:=1 to 38 do write(f,'-');
     writeln(f,'+');
     closefile(f);
     Outweather.Memo.Lines.LoadfromFile(fname);
     count:=count+1;
     wait.gauge1.progress:=round(count/count1*100);

     {Layout of Outphase}
     fname:=defaultdir+'~p.tmp';
     assignfile(f,fname);
     rewrite(f);
     writeln(f);
     write(f,'':30,'');
     if year_default<=0 then write(f,'e ',abs(year_default-1)) else write(f,' ',year_default);
     writeln(f,' ~ (',_tin(tin_default),_dey(dey_default),'~)');
     writeln(f);
     write(f,'+--------+');
     for i:=1 to 4 do write(f,'-------------------+');
     writeln(f);
     write(f,'|A|');
     write(f,'':8,'','':9);
     write(f,'|','':7,'W','':8);
     write(f,'|','':8,'','':9);
     writeln(f,'|','':7,'U','':8,'|');
     write(f,'+--------+');
     for i:=1 to 4 do write(f,'-------------------+');
     writeln(f);
     for i:=0 to num_month do
     begin
          write(f,'|');
          write(f,_name_month(name_month[i]));
          write(f,'|');
          showdt(new_moon[i],i);
          showdt(q1_moon[i],i);
          showdt(full_moon[i],i);
          showdt(q2_moon[i],i);
          writeln(f);
     end;
     write(f,'+--------+');
     for i:=1 to 4 do write(f,'-------------------+');
     writeln(f);
     closefile(f);
     Outphase.Memo.Lines.LoadfromFile(fname);
     count:=count+1;
     wait.gauge1.progress:=round(count/count1*100);

     {Layout of Months}
     for mm:=1 to 12 do
     begin
          fname:=defaultdir+'~m'+_str1(mm)+'.tmp';
          assignfile(f,fname);
          rewrite(f);
          writeln(f);
          write(f,'':30,'');
          if year_default<=0 then write(f,'e ', abs(year_default-1))
             else write(f,' ',year_default);
          write(f,' ~ ');
          writeln(f,_ad_month(mm));
          writeln(f);
          for k:=0 to 6 do write(f,'+----------');
          writeln(f,'+');
          for k:=0 to 6 do
          begin
               write(f,'|');
               write(f,'  ',_dayofweek(-1.5+k),'  ');
          end;
          writeln(f,'|');
          for k:=0 to 6 do write(f,'+----------');
          writeln(f,'+');
          JD:=_JD(year_default,mm,1);
          d:=1;
          repeat
                startJD:=JD;
                for i:=1 to trunc(JD+1.5) mod 7 do write(f,'|','':10);
                write(f,'|');
                repeat
                      if kc then
                         write(f,_tin(round(JD-2449030.5) mod 10),_dey(round(JD-2449030.5) mod 12))
                         else write(f,'    ');
                      write(f,d:6,'|');
                      JD:=JD+1;
                      if (year_default=1582) and (mm=10) and (d=4) then d:=d+11
                         else d:=d+1;
                until (trunc(JD+1.5) mod 7=0) or (JD=_JD(year_default,mm+1,1));
                writeln(f);
                JD:=startJD;
                for i:=1 to trunc(JD+1.5) mod 7 do write(f,'|','':10);
                write(f,'|');
                repeat
                      i:=0;
                      found:=false;
                      leap:=false;
                      repeat
                            if lun_month[i]>JD then
                            begin
                                 dd:=trunc(JD-lun_month[i-1])+1;
                                 found:=true;
                                 m:=name_month[i-1];
                            end;
                            i:=i+1
                      until found or (i>num_month);
                      leap:=m>100;
                      i:=0;
                      repeat
                            i:=i+1
                      until (round(weather[i])-0.5=JD) or (i>24);
                      if i<=24 then write(f,'':6,_name_weather(i))
                         else
                         begin
                              if dd=1 then write(f,'  ',_name_month(m))
                                 else write(f,'':6,_name_day(dd));
                         end;
                      JD:=JD+1;
                      write(f,'|');
                until (trunc(JD+1.5) mod 7=0) or (JD=_JD(year_default,mm+1,1));
                writeln(f);
                for k:=0 to trunc(JD+0.5) mod 7 do write(f,'+----------');
                writeln(f,'+');
          until JD=_JD(year_default,mm+1,1);
          closefile(f);
          count:=count+1;
          wait.gauge1.progress:=round(count/count1*100);
     end;

     {Layout of Lunmonths}
     mm:=1;
     repeat
          fname:=defaultdir+'~l'+_str1(mm)+'.tmp';
          assignfile(f,fname);
          rewrite(f);
          writeln(f);
          write(f,'':24);
          write(f,_tin(tin_default),_dey(dey_default),'~ (');
          if year_default<=0 then write(f,'e ',abs(year_default-1):4) else write(f,' ',year_default:4);
          write(f,' ~ܤ');
          if year_default+1<=0 then write(f,abs(year_default+1):4) else write(f,' ',year_default+1:4);
          writeln(f,' ~) ',_name_month(mm));
          writeln(f);
          for k:=0 to 6 do write(f,'+----------');
          writeln(f,'+');
          for k:=0 to 6 do write(f,'|  ',_dayofweek(-1.5+k),'  ');
          writeln(f,'|');
          for k:=0 to 6 do write(f,'+----------');
          writeln(f,'+');
          i:=0;
          repeat
                i:=i+1
          until name_month[i]=mm;
          if not lun_leap and ((mm mod 100>=10) and (i<5)) then
          repeat
                i:=i+1
          until name_month[i]=mm;
          noday:=no_day[i];
          JD:=lun_month[i];
          dd:=1;
          repeat
                startJD:=JD;
                startdd:=dd;
                for i:=1 to trunc(JD+1.5) mod 7 do write(f,'|','':10);
                write(f,'|');
                repeat
                      if kc then write(f,_tin(round(JD-2449030.5) mod 10),_dey(round(JD-2449030.5) mod 12),'  ')
                         else write(f,'      ');
                      i:=0;
                      repeat
                            i:=i+1
                      until (round(weather[i])-0.5=JD) or (i>28);
                      if i>28 then write(f,_name_day(dd)) else write(f,_name_weather(i));
                      write(f,'|');
                      JD:=JD+1;
                      dd:=dd+1;
                until (trunc(JD+1.5) mod 7=0) or (dd>noday);
                writeln(f);
                JD:=startJD;
                dd:=startdd;
                for i:=1 to trunc(JD+1.5) mod 7 do write(f,'|','':10);
                write(f,'|');
                repeat
                      _invJD(JD,y,m,d);
                      write(f,'  ',d:2,'/',m:2,'/');
                      if y<=0 then write(f,abs(y-1) mod 100:2) else write(f,y mod 100:2);
                      JD:=JD+1;
                      dd:=dd+1;
                      write(f,'|');
                until (trunc(JD+1.5) mod 7=0) or (dd>noday);
                writeln(f);
                for k:=0 to trunc(JD+0.5) mod 7 do write(f,'+----------');
                writeln(f,'+');
          until dd>noday;
          closefile(f);
          if name_leap=mm then mm:=mm+100 else mm:=mm mod 100+1;
          count:=count+1;
          wait.gauge1.progress:=round(count/count1*100);
     until mm=13;

     {Layout of Outholiday}
     fname:=defaultdir+'~h.tmp';
     assignfile(f,fname);
     rewrite(f);
     writeln(f);
     writeln(f,' ',year_default:4,' ~@');
     writeln(f);
     writeln(f,'ҦP:');
     w:=_JD(Year_default,1,1)-1;
     i:=1;
     repeat
           w:=w+1;
     until _dayofweek(w)='P';
     repeat
           _invJD(w,yy,mm,dd);
           write(f,dd:2,'/',mm:2,' ');
           if i=10 then
           begin
                writeln(f);
                i:=1
           end
           else i:=i+1;
           w:=w+7
     until w>_JD(year_default,12,31);
     writeln(f);
     writeln(f);
     write(f,'s~                            : ');
     writeln(f,' 1/ 1/',year_default:4,' ',_dayofweek(_JD(year_default,1,1)));
     write(f,'A~@                            : ');
     i:=0;
     repeat
           i:=i+1
     until name_month[i]=1;
     _invJD(lun_month[i],yy,mm,dd);
     writeln(f,dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(lun_month[i]));
     write(f,'A~G                            : ');
     _invJD(lun_month[i]+1,yy,mm,dd);
     writeln(f,dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(lun_month[i]+1));
     write(f,'A~T                            : ');
     _invJD(lun_month[i]+2,yy,mm,dd);
     writeln(f,dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(lun_month[i]+2));
     write(f,'M`                                : ');
     _invJD(round(weather[7])-0.5,yy,mm,dd);
     writeln(f,dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(_JD(yy,mm,dd)));
     w:=_easter(year_default)-2;
     _invJD(w,yy,mm,dd);
     write(f,'Cq                            : ');
     writeln(f,dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(w));
     write(f,'Cqݤ                        : ');
     _invJD(w+1,yy,mm,dd);
     writeln(f,dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(w+1));
     write(f,'_`                                : ');
     _invJD(w+2,yy,mm,dd);
     writeln(f,dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(w+2));
     write(f,'_`ݤ                            : ');
     _invJD(w+3,yy,mm,dd);
     writeln(f,dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(w+3));
     if year_default>=1999 then
     begin
          write(f,'Ұʸ`                                : ');
          writeln(f,' 1/ 5/',year_default:4,' ',_dayofweek(_JD(year_default,5,1)));
     end;
     if year_default>=1999 then
     begin
          write(f,'                                  : ');
          i:=0;
          repeat
                i:=i+1
          until name_month[i]=4;
          _invJD(lun_month[i]+7,yy,mm,dd);
          writeln(f,dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(lun_month[i]+7));
     end;
     write(f,'ݤȸ`                                : ');
     i:=0;
     repeat
           i:=i+1
     until name_month[i]=5;
     _invJD(lun_month[i]+4,yy,mm,dd);
     writeln(f,dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(lun_month[i]+4));
     if (year_default<1997) and (year_default>=1952) then
     begin
          write(f,'^kӹب                            : ');
          w:=_JD(year_default,5,31);
          i:=0;
          repeat
                i:=i+1
          until round(w+i+1.5) mod 7 = 6;
          w:=w+i+14;
          _invJD(w,yy,mm,dd);
          writeln(f,dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(w));
          write(f,'^kӹبĤ@ӬP@              : ');
          _invJD(w+2,yy,mm,dd);
          writeln(f,dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(w+2));
     end;
     if year_default=1997 then
     begin
          write(f,'^kӹب                            : ');
          w:=_JD(year_default,6,28);
          _invJD(w,yy,mm,dd);
          writeln(f,dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(w));
          write(f,'^kӹبĤ@ӬP@              : ');
          _invJD(w+2,yy,mm,dd);
          writeln(f,dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(w+2));
     end;
     if year_default>=1997 then
     begin
          write(f,'^k                                : ');
          writeln(f,' 1/ 7/',year_default:4,' ',_dayofweek(_JD(year_default,7,1)));
          if year_default=1997 then
          begin
               write(f,'^kݤ                            : ');
               writeln(f,' 2/ 7/',year_default:4,' ',_dayofweek(_JD(year_default,7,2)));
          end;
     end;
     if (year_default<=1996) and (year_default>=1946) then
     begin
          write(f,'K̫@ӬP@e@ӬP    : ');
          w:=_JD(year_default,9,1);
          i:=0;
          repeat
                i:=i+1
          until round(w-i+1.5) mod 7 = 1;
          w:=w-i-2;
          _invJD(w,yy,mm,dd);
          writeln(f,dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(w));
          write(f,'K̫@ӬP@䭫  : ');
          _invJD(w+2,yy,mm,dd);
          writeln(f,dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(w+2));
     end
     else
     if (year_default>=1997) and (year_default<=1998) then
     begin
          write(f,'ܤԪӧQ                    : ');
          w:=_JD(year_default,7,31);
          i:=0;
          repeat
                i:=i+1;
          until round(w+i+1.5) mod 7 = 1;
          w:=w+i+14;
          _invJD(w,yy,mm,dd);
          writeln(f,dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(w));
     end;
     write(f,'`                                : ');
     i:=0;
     repeat
           i:=i+1
     until name_month[i]=8;
     _invJD(lun_month[i]+14,yy,mm,dd);
     writeln(f,dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(lun_month[i]+14));
     if year_default>=1997 then
     begin
          write(f,'y                                : ');
          writeln(f,' 1/10/',year_default:4,' ',_dayofweek(_JD(year_default,10,1)));
     end;
     if (year_default>=1997) and (year_default<=1998) then
     begin
          write(f,'yݤ                            : ');
          writeln(f,' 2/10/',year_default:4,' ',_dayofweek(_JD(year_default,10,2)));
     end;
     write(f,'`                                : ');
     i:=0;
     repeat
           i:=i+1
     until name_month[i]=9;
     _invJD(lun_month[i]+8,yy,mm,dd);
     writeln(f,dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(lun_month[i]+8));
     write(f,'tϸ`                                : ');
     writeln(f,'25/12/',year_default:4,' ',_dayofweek(_JD(year_default,12,25)));
     write(f,'tϸ`ݤ                            : ');
     writeln(f,'26/12/',year_default:4,' ',_dayofweek(_JD(year_default,12,26)));
     writeln(f);
     writeln(f,' ',year_default:4,' ~n`@');
     writeln(f);
     write(f,'ji ');
     i:=0;
     repeat
           i:=i+1
     until name_month[i]=1;
     _invJD(lun_month[i]-1,yy,mm,dd);
     write(f,'(A~',_name_day(trunc(lun_month[i]-lun_month[i-1])),')  : ');
     writeln(f,dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(lun_month[i]-1));
     write(f,'d`               : ');
     i:=0;
     repeat
           i:=i+1
     until name_month[i]=1;
     _invJD(lun_month[i]+14,yy,mm,dd);
     writeln(f,dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(lun_month[i]+14));
     write(f,'H`               : ');
     writeln(f,'14/ 2/',year_default:4,' ',_dayofweek(_JD(year_default,2,14)));
     write(f,'k`               : ');
     writeln(f,' 8/ 3/',year_default:4,' ',_dayofweek(_JD(year_default,3,8)));
     if year_default<=1997 then
     begin
          write(f,'^p             : ');
          w:=_JD(year_default,3,1)-1;
          i:=0;
          repeat
                i:=i+1
          until round(w+i+1.5) mod 7 = 1;
          w:=w+i+7;
          _invJD(w,yy,mm,dd);
          writeln(f,dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(w));
     end;
     write(f,'MH`               : ');
     writeln(f,' 1/ 4/',year_default:4,' ',_dayofweek(_JD(year_default,4,1)));
     write(f,'ൣ`               : ');
     writeln(f,' 4/ 4/',year_default:4,' ',_dayofweek(_JD(year_default,4,4)));
     if (year_default>=1950) and (year_default<=1998) then
     begin
          write(f,'Ұʸ`               : ');
          writeln(f,' 1/ 5/',year_default:4,' ',_dayofweek(_JD(year_default,5,1)));
     end;
     write(f,'˸`               : ');
     w:=_JD(year_default,4,30);
     i:=0;
     repeat
           i:=i+1;
     until round(w+i+1.5) mod 7 = 0;
     w:=w+i+7;
     _invJD(w,yy,mm,dd);
     writeln(f,dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(w));
     if year_default>=1989 then
     begin
          write(f,'|             : ');
          writeln(f,' 4/ 6/',yy:4,' ',_dayofweek(_JD(year_default,6,4)));
     end;
     write(f,'˸`               : ');
     w:=_JD(year_default,5,31);
     i:=0;
     repeat
           i:=i+1;
     until round(w+i+1.5) mod 7 = 0;
     w:=w+i+14;
     _invJD(w,yy,mm,dd);
     writeln(f,dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(w));
{     write(f,'^`         : ');
     i:=0;
     repeat
           i:=i+1
     until name_month[i]=7;
     _invJD(lun_month[i]+6,yy,mm,dd);
     writeln(f,dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(lun_month[i]+6));}
     write(f,'`               : ');
     i:=0;
     repeat
           i:=i+1
     until name_month[i]=7;
     _invJD(lun_month[i]+13,yy,mm,dd);
     writeln(f,dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(lun_month[i]+13));
     if year_default>=1999 then
     begin
          write(f,'ܤԪӧQ   : ');
          w:=_JD(year_default,7,31);
          i:=0;
          repeat
                i:=i+1;
          until round(w+i+1.5) mod 7 = 1;
          w:=w+i+14;
          _invJD(w,yy,mm,dd);
          writeln(f,dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(w));
     end;
     if year_default>=1998 then
     begin
          write(f,'Юv               : ');
          writeln(f,'10/ 9/',year_default:4,' ',_dayofweek(_JD(year_default,9,10)));
     end;
     if year_default>=1912 then
     begin
          write(f,'Q`               : ');
          writeln(f,'10/10/',year_default:4,' ',_dayofweek(_JD(year_default,10,10)));
     end;
     if year_default>=1926 then
     begin
          write(f,']s͹ب       : ');
          writeln(f,'12/11/',year_default:4,' ',_dayofweek(_JD(year_default,11,12)));
     end;
     write(f,'V                 : ');
     _invJD(round(weather[24])-0.5,yy,mm,dd);
     writeln(f,dd:2,'/',mm:2,'/',year_default:4,' ',_dayofweek(_JD(yy,mm,dd)));
     write(f,'w]               : ');
     writeln(f,'24/12/',year_default:4,' ',_dayofweek(_JD(year_default,12,24)));
     write(f,'pi               : ');
     writeln(f,'31/12/',year_default:4,' ',_dayofweek(_JD(year_default,12,31)));
     closefile(f);
     outholiday.memo.lines.loadfromfile(fname);
     count:=count+1;
     wait.gauge1.progress:=round(count/count1*100);

     fname:=defaultdir+'~c2.tmp';
     assignfile(f,fname);
     rewrite(f);
     count:=0;
     for i:=0 to 5 do
         if name_month[i]=1 then
            if round(weather[3])-0.5>=lun_month[i] then count:=count+1;
     for i:=6 to num_month do
         if name_month[i]=1 then
            if round(weather[27])-0.5<lun_month[i] then count:=count+1;
     case count of
          0:    s:=_tin(tin_default)+_dey(dey_default)+'~~';
          1:    s:=_tin(tin_default)+_dey(dey_default)+'~~';
          2:    begin
                     s:=_tin(tin_default)+_dey(dey_default)+'~Kݶ|';
                     if name_leap<11 then s:=s+copy(_name_month(name_leap),5,4)
                        else s:=s+copy(_name_month(name_leap),3,4);
                end;
     end;
     writeln(f,s);
     writeln(f);
     writeln(f,'¦PG');
     found:=false;
     for i:=1 to 12 do
     begin
          w:=_JD(year_default,i,13);
          if trunc(w+1.5) mod 7 =5 then
          begin
               writeln(f,'13/',i:2);
               found:=true;
          end;
     end;
     if not found then writeln(f,'L');
     writeln(f);
     writeln(f,'ŤGG');
     found:=false;
     i:=-1;
     k:=0;
     repeat
           i:=i+1;
     until full_moon[i]>=_JD(year_default,1,1);
     for j:=i to num_month do
     begin
          _invJDH(full_moon[j],yy,l,dd,h,mi,sec);
          if (k=l) and (yy=year_default) then
          begin
               found:=true;
               writeln(f,dd:2,'/',l:2,' ',_dayofweek(_JD(year_default,l,dd)));
          end;
          k:=l;
     end;
     if not found then writeln(f,'L');
     writeln(f);
     _invJD(_easter(year_default),yy,mm,dd);
     writeln(f,'_`G',dd:2,'/',mm:2);
     _invJDH(weather[24],yy,mm,dd,h,mi,sec);
     writeln(f,'Vܡ@G',dd:2,'/',mm:2,' ',_dayofweek(_JD(year_default,mm,dd)));
     closefile(f);
     FirstMenu.memo2.lines.loadfromfile(fname);
     count:=count+1;
     wait.gauge1.progress:=round(count/count1*100);
     // wait.hide;
end;

end.
