program lunarc4D;
uses maths87,crt,day,dos;
const
   ver = '4.13';
   date = '@EEK~EGQC';

var
   q:extended;
   yy,mm,dd,year:integer;
   h,m:integer;
   s:extended;
   i,y,j:integer;
   k:longint;
   { JD of starting of lunar months (exclude leap month) and new moons }
   lun_month,new_moon,q1_moon,full_moon,q2_moon:array[0..19] of extended;
   new_moon_dt,q1_moon_dt,full_moon_dt,q2_moon_dt:array[0..19] of extended;
   { JD of weather }
   weather,weather_dt:array[0..33] of extended;
   { total number of lunar months calculated }
   num_month:integer;
   { names of lunar months and no. of days in lunar months }
   name_month,no_day:array[0..17] of integer;
   { name of leap month, no. of days in the leap month
     and total no. of days in the lunar year }
   name_leap,total_year:integer;
   q1:char;
   tin,dey:integer;
   year1:string;
   jump,leap:boolean;
   aphelion,perihelion,aphelion_dt,perihelion_dt:extended;
   year0,k1,k2,k3:word;

{ Find the exact date of weathers in a year }
function _sun_day(i,y:integer):extended;
var
   f0,w0:extended;
   t:extended;
begin
     if i<=6 then t:=285+(i-1)*15 else t:=(i-6)*15;
     f0:=_JD(y,round(i/2),1);
     w0:=_lambda_sun(f0);
     repeat
           f0:=f0+58*_sin(t-w0);
           w0:=_lambda_sun(f0);
     until (abs(w0-t)<1e-7) or keypressed;
     if keypressed then
     begin
          textcolor(7);
          halt;
     end;
     _sun_day:=f0
end;

{ creation of calendar }
procedure create(year,time:integer;var peh,aph:extended;var leapyear:integer;preleap:integer);
var
   i,j:integer;
   q:extended;
   k:longint;
   y,m,d:integer;
   fixm,fixw:integer;
   try,leap,leaped:boolean;
   A1,A2,A3,A4,A5:extended;
   dum:integer;
   w_d:array[0..33] of extended;
   waste:extended;

begin
     { finding new moons }
     leapyear:=0;
     k:=round((year-2000)*12.3685)+1;
     repeat
           k:=k-1;
           waste:=_phase(k,0);
           q:=round(waste+8/24-dT(waste))-0.5;
     until q<_JD(year,1,1);
     { the new moon just before the year }
     new_moon_dt[0]:=_phase(k,0);
     new_moon[0]:=new_moon_dt[0]+8/24-dT(waste);
     lun_month[0]:=round(new_moon[0])-0.5;
     q1_moon_dt[0]:=_phase(k,1);
     q1_moon[0]:=q1_moon_dt[0]+8/24-dT(waste);
     full_moon_dt[0]:=_phase(k,2);
     full_moon[0]:=full_moon_dt[0]+8/24-dT(waste);
     q2_moon_dt[0]:=_phase(k,3);
     q2_moon[0]:=q2_moon_dt[0]+8/24-dT(waste);
     { the new moons within the year }
     i:=0;
     repeat
           k:=k+1;
           i:=i+1;
           new_moon_dt[i]:=_phase(k,0);
           new_moon[i]:=new_moon_dt[i]+8/24-dT(waste);
           lun_month[i]:=round(new_moon[i])-0.5;
           q1_moon_dt[i]:=_phase(k,1);
           q1_moon[i]:=q1_moon_dt[i]+8/24-dT(waste);
           full_moon_dt[i]:=_phase(k,2);
           full_moon[i]:=full_moon_dt[i]+8/24-dT(waste);
           q2_moon_dt[i]:=_phase(k,3);
           q2_moon[i]:=q2_moon_dt[i]+8/24-dT(waste);
     until lun_month[i]>=_JD(year+1,1,1);
     { the new moon just after the year }
     for j:=1 to 3 do
     begin
          new_moon_dt[i+j]:=_phase(k+j,0);
          new_moon[i+j]:=new_moon_dt[i+j]+8/24-dT(waste);
          q1_moon_dt[i+j]:=_phase(k+j,1);
          q1_moon[i+j]:=q1_moon_dt[i+j]+8/24-dT(waste);
          full_moon_dt[i+j]:=_phase(k+j,2);
          full_moon[i+j]:=full_moon_dt[i+j]+8/24-dT(waste);
          q2_moon_dt[i+j]:=_phase(k+j,3);
          q2_moon[i+j]:=q2_moon_dt[i+j]+8/24-dT(waste);
          lun_month[i+j]:=round(new_moon[i+j])-0.5;
     end;
     num_month:=i+2;
{     for i:=0 to num_month do
         if (year<=1911) and ((new_moon[i]-lun_month[i])*24>=23.0) then lun_month[i]:=lun_month[i]+1;}
     { finding weathers }
     for i:=0 to 32 do
     begin
          if i=0 then
          begin
               weather_dt[0]:=_sun_day(24,year-1);
               weather[0]:=weather_dt[0]+8/24-dT(waste)
          end
             else if i>=25 then
             begin
                  weather_dt[i]:=_sun_day(i-24,year+1);
                  weather[i]:=weather_dt[i]+8/24-dT(waste)
             end
                  else
                  begin
                       weather_dt[i]:=_sun_day(i,year);
                       weather[i]:=weather_dt[i]+8/24-dT(waste);
                  end;
          w_d[i]:=round(weather[i])-0.5;
{          if ((weather[i]-w_d[i])*24>23.0) and (year<=1911) then w_d[i]:=w_d[i]+1;}
          gotoxy(1,16);
          writeln('ws䤧ʤ: ',round((i+time*32)/64*100):3,'%');
     end;
     { finding perihelion and aphelion }
     dum:=year;
     try:=false;
     repeat
           aph:=round(0.99997*(dum-2000.01))+0.5;
           A1:=328.41+132.788585*aph;
           A2:=316.13+584.903153*aph;
           A3:=346.20+450.380738*aph;
           A4:=136.95+659.306737*aph;
           A5:=249.52+329.653368*aph;
           aph:=2451547.507+365.2596358*aph+1.58e-8*sqr(aph);
           aphelion_dt:=aph-1.352*_sin(A1)+0.061*_sin(A2)+0.062*_sin(A3)+0.029*_sin(A4)+0.031*_sin(A5);
           aph:=round(aphelion_dt+8/24-dT(aphelion_dt))-0.5;
           if aph<_JD(year,1,1) then
           begin
                dum:=dum+1;
                try:=true;
           end;
           if aph>_JD(year,12,31) then
           begin
                dum:=dum-1;
                try:=true;
           end;
     until ((aph>=_JD(year,1,1)) and (aph<=_JD(year,12,31))) or try;
     dum:=year;
     try:=false;
     repeat
           peh:=round(0.99997*(dum-2000.01));
           A1:=328.41+132.788585*peh;
           A2:=316.13+584.903153*peh;
           A3:=346.20+450.380738*peh;
           A4:=136.95+659.306737*peh;
           A5:=249.52+329.653368*peh;
           peh:=2451547.507+365.2596358*peh+1.58e-8*sqr(peh);
           perihelion_dt:=peh+1.278*_sin(A1)-0.055*_sin(A2)-0.091*_sin(A3)-0.056*_sin(A4)-0.045*_sin(A5);
           peh:=round(perihelion_dt+8/24-dT(perihelion_dt))-0.5;
           if peh<_JD(year,1,1) then
           begin
                dum:=dum+1;
                try:=true;
           end;
           if peh>_JD(year,12,31) then
           begin
                dum:=dum-1;
                try:=true;
           end;
     until ((peh>=_JD(year,1,1)) and (peh<=_JD(year,12,31))) or try;
     i:=-1;
     repeat
           i:=i+1;
     until abs(aph-w_d[2*i])<30;
     fixw:=i;
     if fixw>11 then fixw:=fixw-12;
     j:=-1;
     repeat
           j:=j+1;
     until (lun_month[j]<=w_d[2*fixw]) and (lun_month[j+1]>w_d[2*fixw]);
     fixm:=j;
     name_month[fixm]:=fixw-1;
     if name_month[fixm]>12 then name_month[fixm]:=name_month[fixm]-12;
     if name_month[fixm]<=0 then name_month[fixm]:=name_month[fixm]+12;
     i:=0;
     leaped:=false;
     repeat
           i:=i+1;
           j:=fixm-i;
           if name_month[j+1]>100 then name_month[j]:=name_month[j+1]-100
              else name_month[j]:=name_month[j+1]-1;
           if name_month[j]>12 then name_month[j]:=name_month[j]-12;
           if name_month[j]<1 then name_month[j]:=name_month[j]+12;
           if (j<5) and (name_month[j]>10) then leap:=preleap=name_month[j] else leap:=false;
           if (leap and not leaped) or (w_d[2*(fixw-i)]<lun_month[j])
              and (leapyear=0) and (preleap=0) then
           begin
                name_month[j]:=name_month[j]+100;
                leapyear:=name_month[j]-100;
                leaped:=true;
           end;
     until i=fixm;
     i:=0;
     repeat
           i:=i+1;
           j:=fixm+i;
           name_month[j]:=name_month[j-1] mod 100+1;
           if name_month[j]>12 then name_month[j]:=name_month[j]-12;
           if name_month[j]<1 then name_month[j]:=name_month[j]+12;
           if (w_d[2*(fixw+i)]>=lun_month[j+1]) and (leapyear=0) and (preleap=0) then
           begin
                name_month[j]:=name_month[j-1]+100;
                leapyear:=name_month[j-1];
                leaped:=true;
           end;
     until i+fixm=num_month;
     leapyear:=0;
     for i:=0 to num_month do no_day[i]:=round(lun_month[i+1]-lun_month[i]);
     k:=-1;
     repeat
           k:=k+1
     until name_month[k]=1;
     j:=num_month+1;
     repeat
           j:=j-1;
     until (name_month[j]=112) or ((name_month[j]=12) and (name_month[j+1]=1));
     total_year:=0;
     for i:=k to j do
     begin
          total_year:=total_year+no_day[i];
          if name_month[i]>100 then leapyear:=name_month[i]-100;
     end;
end;

{ Aऽ }
procedure ltos;
var
   i:integer;
   m,d,y:integer;
   JD:extended;
   c:char;
   exist,leap:boolean;
   mmm,ddd:string;

begin
     repeat
           repeat
                 clrscr;
                 writeln('пJA:');
                 write(' ( ''ENTER'' })');
                 readln(mmm);
                 val(mmm,mm,i);
                 if mmm<>'' then
                 begin
                      write(' ( ''ENTER'' })');
                      readln(ddd);
                      val(ddd,dd,i);
                 end;
           until ((mm>0) and (mm<13) and (dd>0) and (dd<=30)) or (mmm='') or (ddd='');
           if (mmm<>'') and (ddd<>'') then
           begin
                writeln;
                exist:=false;
                for i:=0 to num_month do
                if (name_month[i]=mm) or (name_month[i]=mm+100) then
                begin
                     if name_month[i]=mm then leap:=false
                        else leap:=true;
                     JD:=lun_month[i]+dd-1;
                     _invJD(JD,y,m,d);
                     if dd<=no_day[i] then
                     begin
                          exist:=true;
                          textcolor(14);
                          writeln(' ':8,'         A                        ');
                          writeln(' ':41,'P             ~');
                          writeln;
                          write('':10);
                          if ((mm mod 100>=10) and (m<3) and (y=year)) or (y<year) then
                          begin
                               if leap then textcolor(4) else textcolor(3);
                               write(_tin(tin-1),_dey(dey-1))
                          end
                          else if (mm mod 100<=3) and (y>year) then
                          begin
                               if leap then textcolor(4) else textcolor(3);
                               write(_tin(tin+1),_dey(dey+1))
                          end
                          else
                          begin
                               if leap then textcolor(12) else textcolor(11);
                               write(_tin(tin),_dey(dey))
                          end;
                          write('~');
                          write(_name_month(name_month[i]),_name_day(dd),'');
                          write(_tin(round(JD-2449030.5) mod 10),_dey(round(JD-2449030.5) mod 12));
                          if y=year then textcolor(10) else textcolor(2);
                          write('':6,_dayofweek(_JD(y,m,d)),'    ',d:2,'   ',m:2,'   ');
                          if y<=0 then writeln(abs(y-1):4,' BC') else writeln('AD ',y:4);
                          writeln;
                          writeln;
                     end;
                end;
                textcolor(7);
                writeln;
                if not exist then
                begin
                     textcolor(12);
                     writeln(#7,'o@Ѩäsb.');
                     textcolor(7);
                     writeln
                end;
                write('Ы@~ ( ''ESC'' } )');
                c:=readkey;
                if c=#0 then c:=readkey
           end;
     until (c=#27) or (mmm='') or (ddd='');
end;

{ A }
procedure stol;
var
   i:integer;
   m,d,y:integer;
   JD:extended;
   c:char;
   max_sday:integer;
   found,leap:boolean;
   mmm,ddd:string;

begin
     repeat
     mm:=0;
     dd:=0;
           repeat
                 clrscr;
                 writeln('пJ ',year,' ~ :');
                 write(' ( ''ENTER'' }');
                 if year=year0 then write(', ''@'' tΤ)')
                    else write(')');
                 readln(mmm);
                 if (mmm<>'') and (mmm<>'@') then
                 begin
                      val(mmm,mm,i);
                      write(' ( ''ENTER'' })');
                      readln(DDD);
                      val(DDD,DD,i);
                      case MM of
                           1,3,5,7,8,12: max_sday:=31;
                           4,6,9,11: max_sday:=30;
                           2: if year mod 4<>0 then max_sday:=28
                              else if (year mod 400<>0) and (year mod 100=0) and (year>1582) then max_sday:=28
                                 else max_sday:=29;
                           10: if year<>1582 then max_sday:=31
                               else if (DD>4) and (DD<14) then max_sday:=-1
                                    else max_sday:=31;
                              else max_sday:=-1;
                      end;
                 end;
           until ((MM>0) and (MM<=12) and (DD>0) and (DD<=max_sday)) or (mmm='') or (ddd='') or ((mmm='@') and (year=year0));
           if (mmm='@') and (year=year0) then
           begin
                getdate(year0,k1,k2,k3);
                MM:=k1;
                DD:=k2;
                mmm:='g';
                ddd:='g'
           end;
           if ((mmm='@') and (year=year0)) or ((mmm<>'') and (ddd<>'')) then
           begin
                writeln;
                JD:=_JD(year,MM,DD);
                i:=0;
                found:=false;
                leap:=false;
                repeat
                      if lun_month[i]>JD then
                      begin
                           d:=trunc(JD)-trunc(lun_month[i-1])+1;
                           found:=true;
                           m:=name_month[i-1];
                      end;
                      i:=i+1
                until found or (i>num_month);
                if m>100 then leap:=true;
                textcolor(14);
                writeln(' ':9,'                                    A');
                writeln(' ':9,'P             ~');
                writeln;
                textcolor(10);
                JD:=_JD(year,mm,dd);
                write('':8,_dayofweek(JD),'    ',dd:2,'   ',mm:2,'   ');
                if year<=0 then write(abs(year-1):4,' BC') else write('AD ',year:4);
                write('':9);
                if (m mod 100>=10) and (mm<3) then
                begin
                     if leap then textcolor(4) else textcolor(3);
                     write(_tin(tin-1),_dey(dey-1))
                end
                else
                begin
                     if leap then textcolor(12) else textcolor(11);
                     write(_tin(tin),_dey(dey));
                end;
                write('~');
                write(_name_month(m),_name_day(d),'');
                writeln(_tin(round(JD-2449030.5) mod 10),_dey(round(JD-2449030.5) mod 12));
                textcolor(7);
                writeln;
                write('Ы@~ ( ''ESC'' } )');
                c:=readkey;
                if c=#0 then c:=readkey
           end;
     until (c=#27) or (ddd='') or (mmm='');
end;

{ X }
procedure printmonth(var g:text;mm:integer;kc:boolean);
var
   JD,startJD:extended;
   m,dd,d,y:integer;
   found:boolean;
   i,j,k:integer;
begin
     writeln(g);
     write(g,'':30);
     write(g,'');
     if year<=0 then write(g,'e ', abs(year-1)) else write(g,' ',year);
     write(g,' ~ ');
     write(g,_ad_month(mm));
     writeln(g);
     for k:=0 to 6 do write(g,'+----------');
     writeln(g,'+');
     for k:=0 to 6 do
     begin
          write(g,'|  ',_dayofweek(-1.5+k),'  ');
     end;
     writeln(g,'|');
     for k:=0 to 6 do write(g,'+----------');
     writeln(g,'+');
     JD:=_JD(year,mm,1);
     d:=1;
     repeat
           startJD:=JD;
           for i:=1 to trunc(JD+1.5) mod 7 do write(g,'|','':10);
           write(g,'|');
           repeat
                 if kc then write(g,_tin(round(JD-2449030.5) mod 10),_dey(round(JD-2449030.5) mod 12))
                 else write(g,'    ');
                 write(g,d:6);
                 write(g,'|');
                 JD:=JD+1;
                 if (year=1582) and (mm=10) and (d=4) then d:=d+11
                    else d:=d+1;
           until (trunc(JD+1.5) mod 7=0) or (JD=_JD(year,mm+1,1));
           writeln(g);
           JD:=startJD;
           for i:=1 to trunc(JD+1.5) mod 7 do write(g,'|','':10);
           write(g,'|');
           repeat
                 i:=0;
                 found:=false;
                 repeat
                       if lun_month[i]>JD then
                       begin
                            dd:=trunc(JD-lun_month[i-1])+1;
                            found:=true;
                            m:=name_month[i-1];
                       end;
                       i:=i+1
                 until found or (i>num_month);
                 i:=0;
                 repeat
                       i:=i+1
                 until (round(weather[i])-0.5=JD) or (i>24);
                 if i<=24 then write(g,'':6,_name_weather(i))
                    else
                    begin
                         if dd=1 then write(g,'  ',_name_month(m))
                            else write(g,'':6,_name_day(dd));
                    end;
                 JD:=JD+1;
                 write(g,'|');
           until (trunc(JD+1.5) mod 7=0) or (JD=_JD(year,mm+1,1));
           writeln(g);
           for k:=0 to trunc(JD+0.5) mod 7 do
           write(g,'+----------');
           writeln(g,'+');
     until JD=_JD(year,mm+1,1);
     writeln(g);
end;

{ ܤ@Ӥ }
procedure outmonth;
var
   mm:integer;
   JD,startJD:extended;
   m,dd,d,y:integer;
   found,leap,kc,ct:boolean;
   c:char;
   g:text;
   me,mmm:string;

begin
     ct:=false;
     repeat
           if not ct then
           begin
                repeat
                      clrscr;
                      write('пJ ',year,' ~ ( ''ENTER'' }): ');
                      readln(mmm);
                      val(mmm,mm,i);
                until ((mm>0) and (mm<13)) or (mmm='');
                if mmm<>'' then
                begin
                     write('O_CXz(y/N) ?');
                     c:=readkey;
                     if c=#0 then c:=readkey;
                     kc:=(c='y') or (c='Y');
                end;
           end;
           if mmm<>'' then
           begin
                clrscr;
                writeln;
                textcolor(14);
                write('':30);
                write('');
                if year<=0 then write('e ', abs(year-1)) else write(' ',year);
                write(' ~ ');
                write(_ad_month(mm));
                writeln;
                textcolor(7);
                for k:=0 to 6 do write('+----------');
                writeln('+');
                for k:=0 to 6 do
                begin
                     write('|');
                     textcolor(9);
                     write('  ',_dayofweek(-1.5+k),'  ');
                     textcolor(7);
                end;
                writeln('|');
                for k:=0 to 6 do write('+----------');
                writeln('+');
                JD:=_JD(year,mm,1);
                d:=1;
                repeat
                      startJD:=JD;
                      for i:=1 to trunc(JD+1.5) mod 7 do write('|','':10);
                      write('|');
                      repeat
                            textcolor(13);
                            if kc then write(_tin(round(JD-2449030.5) mod 10),_dey(round(JD-2449030.5) mod 12))
                               else write('    ');
                            textcolor(10);
                            write(d:6);
                            textcolor(7);
                            write('|');
                            JD:=JD+1;
                            if (year=1582) and (mm=10) and (d=4) then d:=d+11
                               else d:=d+1;
                      until (trunc(JD+1.5) mod 7=0) or (JD=_JD(year,mm+1,1));
                      writeln;
                      JD:=startJD;
                      for i:=1 to trunc(JD+1.5) mod 7 do write('|','':10);
                      write('|');
                      repeat
                            i:=0;
                            found:=false;
                            leap:=false;
                            repeat
                                  if lun_month[i]>JD then
                                  begin
                                       dd:=trunc(JD-lun_month[i-1])+1;
                                       found:=true;
                                       m:=name_month[i-1];
                                  end;
                                  i:=i+1
                            until found or (i>num_month);
                            leap:=m>100;
                            i:=0;
                            repeat
                                  i:=i+1
                            until (round(weather[i])-0.5=JD) or (i>24);
                            if leap then textcolor(12) else textcolor(11);
                            if i<=24 then write('':6,_name_weather(i))
                            else
                            begin
                                 if dd=1 then write('  ',_name_month(m))
                                    else write('':6,_name_day(dd));
                            end;
                            JD:=JD+1;
                            textcolor(7);
                            write('|');
                      until (trunc(JD+1.5) mod 7=0) or (JD=_JD(year,mm+1,1));
                      writeln;
                      for k:=0 to trunc(JD+0.5) mod 7 do
                      write('+----------');
                      writeln('+');
                until JD=_JD(year,mm+1,1);
                gotoxy(1,25);
                write('Ы@~ ( ''+'' U@Ӥ, ''-'' W@Ӥ,');
                write(' ''P'' XɮשΦLr, ''ESC'' } )');
                c:=readkey;
                if c=#0 then c:=readkey;
                ct:=true;
                case c of
                     '+',#81:   if mm<12 then mm:=mm+1;
                     '-',#73:   if mm>1 then mm:=mm-1;
                     'p','P':   begin
                                     gotoxy(1,25);
                                     write('':79);
                                     gotoxy(1,24);
                                     write('пJɦW(u ENTER Lr): ');
                                     readln(me);
                                     if me='' then assign(g,'prn')
                                        else assign(g,me);
                                     rewrite(g);
                                     printmonth(g,mm,kc);
                                     close(g)
                                end;
                     else ct:=false
                end
           end
     until (c=#27) or (mmm='');
end;

{ ܤ@ӹA }
procedure outlunmonth;
var
   mm:integer;
   JD,startJD:extended;
   m,dd,d,y,startdd:integer;
   leap,kc,ct:boolean;
   c:char;
   noday:extended;
   g:text;
   me,mmm:string;

begin
     ct:=false;
     repeat
           if not ct then
                repeat
                      clrscr;
                      write('пJ',_tin(tin),_dey(dey),'~A ( ''ENTER'' }) :');
                      readln(mmm);
                      val(mmm,mm,i);
                until ((mm>0) and (mm<13)) or (mmm='');
                if (mmm<>'') and not ct then
                begin
                     if name_leap=mm then
                     begin
                          writeln('1 : ',_name_month(mm),'':5,'2 : |',_name_month(mm));
                          write('п : ');
                          repeat
                                c:=readkey;
                                if c=#0 then c:=readkey
                          until (c='1') or (c='2');
                          if c='2' then
                          begin
                               leap:=true;
                               mm:=mm+100
                          end
                          else leap:=false;
                          writeln(c);
                     end
                     else leap:=false;
                     write('O_CXz(y/N) ?');
                     c:=readkey;
                     if c=#0 then c:=readkey;
                     kc:=(c='y') or (c='Y');
                end;
                if mmm<>'' then
                begin
                     clrscr;
                     writeln;
                     textcolor(14);
                     write('':24);
                     write(_tin(tin),_dey(dey),'~ (');
                     if year<=0 then write(abs(year-1):4,' BC') else write('AD ',year:4);
                     if year+1<=0 then write(abs(year+1):4,' - BC') else write(' - AD ',year+1:4);
                     write(') ');
                     if leap then textcolor(12);
                     writeln(_name_month(mm));
                     writeln;
                     textcolor(7);
                     for k:=0 to 6 do write('+----------');
                     writeln('+');
                     for k:=0 to 6 do
                     begin
                          write('|');
                          textcolor(9);
                          write('  ',_dayofweek(-1.5+k),'  ');
                          textcolor(7);
                     end;
                     writeln('|');
                     for k:=0 to 6 do write('+----------');
                     writeln('+');
                     i:=0;
                     repeat
                           i:=i+1
                     until name_month[i]=mm;
                     if not leap and ((mm>=10) and (i<5)) then
                     repeat
                           i:=i+1
                     until name_month[i]=mm;
                     noday:=no_day[i];
                     JD:=lun_month[i];
                     dd:=1;
                     repeat
                           startJD:=JD;
                           startdd:=dd;
                           for i:=1 to trunc(JD+1.5) mod 7 do write('|','':10);
                           write('|');
                           repeat
                                 textcolor(13);
                                 if kc then write(_tin(round(JD-2449030.5) mod 10),_dey(round(JD-2449030.5) mod 12),'  ')
                                    else write('      ');
                                 if leap then textcolor(12) else textcolor(11);
                                 i:=0;
                                 repeat
                                       i:=i+1
                                 until (round(weather[i])-0.5=JD) or (i>28);
                                 if i>28 then write(_name_day(dd)) else write(_name_weather(i));
                                 textcolor(7);
                                 write('|');
                                 JD:=JD+1;
                                 dd:=dd+1;
                           until (trunc(JD+1.5) mod 7=0) or (dd>noday);
                           writeln;
                           JD:=startJD;
                           dd:=startdd;
                           for i:=1 to trunc(JD+1.5) mod 7 do write('|','':10);
                           write('|');
                           repeat
                                 _invJD(JD,y,m,d);
                                 textcolor(10);
                                 write('  ',d:2,'/',m:2,'/');
                                 if y<=0 then write(abs(y-1) mod 100:2) else write(y mod 100:2);
                                 JD:=JD+1;
                                 dd:=dd+1;
                                 textcolor(7);
                                 write('|');
                           until (trunc(JD+1.5) mod 7=0) or (dd>noday);
                           writeln;
                           for k:=0 to trunc(JD+0.5) mod 7 do write('+----------');
                           writeln('+');
                     until dd>noday;
                     gotoxy(1,25);
                     write('Ы@~ ( ''+'' U@Ӥ, ''-'' W@Ӥ,');
                     write(' ''P'' XɮשΦLr, ''ESC'' } )');
                     c:=readkey;
                     if c=#0 then c:=readkey;
                     ct:=true;
                     case c of
                          '+',#81:if mm mod 100<12 then
                                  begin
                                       if (name_leap=mm) and not leap then
                                       begin
                                            mm:=mm+100;
                                            leap:=true;
                                       end
                                       else
                                       begin
                                            mm:=mm mod 100+1;
                                            leap:=false;
                                       end
                                  end
                                  else
                                  if (name_leap=12) and not leap then
                                  begin
                                        mm:=mm+100;
                                        leap:=true;
                                  end;
                          '-',#73:if mm mod 100>1 then
                                  begin
                                       if mm=name_leap+1 then
                                       begin
                                            mm:=mm-1+100;
                                            leap:=true;
                                       end
                                       else
                                       if mm<100 then
                                       begin
                                            mm:=mm-1;
                                            leap:=false;
                                       end
                                       else
                                       begin
                                            mm:=mm-100;
                                            leap:=false;
                                       end
                                  end
                                  else
                                  if (name_leap=1) and leap then
                                  begin
                                       mm:=mm-100;
                                       leap:=false;
                                  end;
                          'p','P':
                                  begin
                                       gotoxy(1,25);
                                       write('':79);
                                       gotoxy(1,24);
                                       write('пJɦW(u ENTER Lr): ');
                                       readln(me);
                                       if me='' then assign(g,'prn')
                                          else assign(g,me);
                                       rewrite(g);
                                       writeln(g);
                                       write(g,'':24,_tin(tin),_dey(dey),'~ (');
                                       if year<=0 then write(g,abs(year-1):4,' BC') else write(g,'AD ',year:4);
                                       if year+1<=0 then write(g,abs(year+1):4,' - BC') else write(g,' - AD ',year+1:4);
                                       write(g,') ');
                                       writeln(g,_name_month(mm));
                                       writeln(g);
                                       for k:=0 to 6 do write(g,'+----------');
                                       writeln(g,'+');
                                       for k:=0 to 6 do write(g,'|  ',_dayofweek(-1.5+k),'  ');
                                       writeln(g,'|');
                                       for k:=0 to 6 do write(g,'+----------');
                                       writeln(g,'+');
                                       i:=0;
                                       repeat
                                             i:=i+1
                                       until name_month[i]=mm;
                                       if not leap and ((mm>=10) and (i<5)) then
                                       repeat
                                             i:=i+1
                                       until name_month[i]=mm;
                                       noday:=no_day[i];
                                       JD:=lun_month[i];
                                       dd:=1;
                                       repeat
                                             startJD:=JD;
                                             startdd:=dd;
                                             for i:=1 to trunc(JD+1.5) mod 7 do write(g,'|','':10);
                                             write(g,'|');
                                             repeat
                                                   if kc then
                                                   begin
                                                        write(g,_tin(round(JD-2449030.5) mod 10));
                                                        write(g,_dey(round(JD-2449030.5) mod 12),'  ')
                                                   end
                                                      else write(g,'      ');
                                                   i:=0;
                                                   repeat
                                                         i:=i+1
                                                   until (round(weather[i])-0.5=JD) or (i>28);
                                                   if i>28 then write(g,_name_day(dd)) else write(g,_name_weather(i));
                                                   write(g,'|');
                                                   JD:=JD+1;
                                                   dd:=dd+1;
                                             until (trunc(JD+1.5) mod 7=0) or (dd>noday);
                                             writeln(g);
                                             JD:=startJD;
                                             dd:=startdd;
                                             for i:=1 to trunc(JD+1.5) mod 7 do write(g,'|','':10);
                                             write(g,'|');
                                             repeat
                                                   _invJD(JD,y,m,d);
                                                   write(g,'  ',d:2,'/',m:2,'/');
                                                   if y<=0 then write(g,abs(y-1) mod 100:2) else write(g,y mod 100:2);
                                                   JD:=JD+1;
                                                   dd:=dd+1;
                                                   write(g,'|');
                                             until (trunc(JD+1.5) mod 7=0) or (dd>noday);
                                             writeln(g);
                                             for k:=0 to trunc(JD+0.5) mod 7 do write(g,'+----------');
                                             writeln(g,'+');
                                       until dd>noday;
                                       close(g);
                                  end;
                                  else ct:=false;
                     end;
                end;
     until (c=#27) or (mmm='');
end;

{ z~ऽ~ }
procedure tindeyto;
var
   i,tin1,dey1,p:integer;
   c:char;
   tin2,dey2:string;

begin
     repeat
           repeat
                  clrscr;
                  for i:=0 to 9 do write(i,_tin(i),' ');
                  writeln;
                  write('пJѤz ( ''ENTER'' }) : ');
                  readln(tin2);
                  val(tin2,tin1,i);
                  if tin2<>'' then
                  begin
                       for i:=0 to 11 do write(i,_dey(i),' ');
                       writeln;
                       write('пJa ( ''ENTER'' }) : ');
                       readln(dey2);
                       val(dey2,dey1,i);
                  end;
            until ((tin1>=0) and (tin1<10) and (dey1>=0) and (dey1<12)) or (tin2='') or (dey2='');
            if (tin2<>'') and (dey2<>'') then
            begin
                 if not odd(tin1+dey1) then
                 begin
                      i:=tin1;
                      while (i mod 12 <> dey1) do i:=i+10;
                      p:=1984+i;
                      repeat
                            p:=p-60
                      until p-60<-2636;
                      clrscr;
                      writeln('HU~A',_tin(tin1),_dey(dey1),'~:');
                      writeln;
                      repeat
                            if abs(p-year)<60 then textcolor(13) else textcolor(10);
                            if p<=0 then write(abs(p-1):4,' BC   ') else write('AD',p:5,'   ');
                            p:=p+60;
                      until p>4000;
                      writeln;
                      writeln;
                      textcolor(7);
                      write(', Ы@~ ( ''ESC'' } )');
                      c:=readkey;
                      if c=#0 then c:=readkey;
                      if c<>#27 then
                      begin
                           clrscr;
                           writeln('HU~A',_tin(tin1),_dey(dey1),'~:');
                           writeln;
                           repeat
                                 if abs(p-year)<60 then textcolor(13) else textcolor(10);
                                 if p<=0 then write(abs(p-1):4,' BC   ') else write('AD',p:5,'   ');
                                 p:=p+60;
                           until p>11000;
                      end;
                 end
                 else
                 begin
                      textcolor(12);
                      writeln(#7,'z~äsb !');
                 end;
                 if c<>#27 then
                 begin
                      writeln;
                      writeln;
                      textcolor(7);
                      write('Ы@~ ( ''ESC'' } )');
                      c:=readkey;
                      if c=#0 then c:=readkey;
                 end
            end
      until (c=#27) or (tin2='') or (dey2='');
end;

{ ~z~ }
procedure totindey;
var
   i,tin1,dey1:integer;
   c:char;
   ii:string;

begin
     repeat
           repeat
                 clrscr;
                 write('пJ~ (AD -2636 ~ΥH,  ''ENTER'' }) : ');
                 readln(ii);
                 val(ii,i,tin1);
           until (i>=-2636) or (ii='');
           if ii<>'' then
           begin
                writeln;
                tin1:=(i-1984) mod 10;
                dey1:=(i-1984) mod 12;
                textcolor(14);
                write('');
                if i<=0 then write('e ') else write(' ');
                textcolor(10);
                if i<=0 then write(abs(i-1),' (AD ',i,')') else write(i);
                textcolor(14);
                write(' ~O ');
                textcolor(11);
                write(_tin(tin1),_dey(dey1),'~');
                textcolor(14);
                writeln('.');
                textcolor(7);
                writeln;
                write('Ы@~ (''ESC'' } )');
                c:=readkey;
                if c=#0 then c:=readkey
           end
     until (c=#27) or (ii='');
end;

{ ܤܥ|` Ѯ}
procedure show_weather_et;
var
   i,k,j,l,d,m,y,dd,mm,yy,sec00:integer;
   found,leap:boolean;
   c:char;
   count:integer;
   h,sec:extended;
   hr,min:integer;

begin
     clrscr;
     writeln;
     textcolor(14);
     write('':22,'');
     if year<=0 then write('e ',abs(year-1)) else write(' ',year);
     writeln(' ~');
     textcolor(7);
     writeln;
     write('+');
     for i:=1 to 27 do write('-');
     write('+');
     for i:=1 to 27 do write('-');
     writeln('+');
     write('|','':12);
     textcolor(9);
     write('`');
     textcolor(7);
     write('':11,'|','':12);
     textcolor(13);
     write('');
     textcolor(7);
     writeln('':11,'|');
     write('+');
     for i:=1 to 27 do write('-');
     write('+');
     for i:=1 to 27 do write('-');
     writeln('+');
     for j:=1 to 12 do
     begin
          for k:=0 to 1 do
          begin
               l:=2*j-1+k;
               _invJD(round(weather_dt[l])-0.5,yy,mm,dd);
               h:=(weather_dt[l]-round(weather_dt[l])+0.5)*24;
               dms(h,hr,min,sec);
               sec00:=trunc(sec);
               write('|');
               if k=0 then textcolor(9) else textcolor(13);
               write(_name_weather(l));
               textcolor(7);
               write(':');
               if (yy<year) or (yy>year) then textcolor(2) else textcolor(10);
               write(dd:2,'/',mm:2,'/',yy:5,'  ');
               write(hr:2,':',min:2,':',sec00:2,' ');
               textcolor(7);
               if k=1 then writeln('|');
          end;
     end;
     textcolor(7);
     write('+');
     for i:=1 to 27 do write('-');
     write('+');
     for i:=1 to 27 do write('-');
     writeln('+');
     textcolor(14);
     writeln(': HWҦܮɶѮɡOǮ');
     textcolor(7);
     writeln;
     write('Ы@}');
     c:=readkey;
     if c=#0 then c:=readkey
end;

{ ܤܥ|`  }
procedure show_weather;
var
   i,k,j,l,d,m,y,dd,mm,yy:integer;
   found,leap:boolean;
   c:char;
   count:integer;
   h,sec:extended;
   hr,min:integer;

begin
     clrscr;
     writeln;
     textcolor(14);
     write('':29,'');
     if year<=0 then write('e ',abs(year-1)) else write(' ',year);
     writeln(' ~ (',_tin(tin),_dey(dey),'~)');
     textcolor(7);
     writeln;
     write('+');
     for i:=1 to 38 do write('-');
     write('+');
     for i:=1 to 38 do write('-');
     writeln('+');
     write('|','':17);
     textcolor(9);
     write('`');
     textcolor(7);
     write('':17,'|','':17);
     textcolor(13);
     write('');
     textcolor(7);
     writeln('':17,'|');
     write('+');
     for i:=1 to 38 do write('-');
     write('+');
     for i:=1 to 38 do write('-');
     writeln('+');
     for j:=1 to 14 do
     begin
          for k:=0 to 1 do
          begin
               l:=2*j-1+k;
               _invJD(round(weather[l])-0.5,yy,mm,dd);
               h:=(weather[l]-round(weather[l])+0.5)*24;
               dms(h,hr,min,sec);
               write('|');
               if k=0 then textcolor(9) else textcolor(13);
               write(_name_weather(l));
               textcolor(7);
               write(':');
               if (yy<year) or (yy>year) then textcolor(2) else textcolor(10);
               write(dd:2,'/',mm:2,' ');
               write(hr:2,':',min:2,' ',copy(_dayofweek(round(weather[l])-0.5),5,2),' ');
               i:=0;
               found:=false;
               leap:=false;
               repeat
                     if lun_month[i]>round(weather[l])-0.5 then
                     begin
                          d:=trunc(round(weather[l])-0.5)-trunc(lun_month[i-1])+1;
                          found:=true;
                          m:=name_month[i-1];
                     end;
                     i:=i+1
               until found or (i>num_month);
               if m>100 then leap:=true;
               if (yy>year) and (m mod 100<=3) then
               begin
                    if leap then textcolor(4) else textcolor(3);
                    write(_tin(tin+1),_dey(dey+1))
               end
                  else if yy>year then
                       begin
                            if leap then textcolor(12) else textcolor(11);
                            write(_tin(tin),_dey(dey))
                       end
                       else if (yy<year) or ((m mod 100>=10) and (mm<3)) then
                            begin
                                 if leap then textcolor(4) else textcolor(3);
                                 write(_tin(tin-1),_dey(dey-1))
                            end
                            else
                            begin
                                 if leap then textcolor(12) else textcolor(11);
                                 write(_tin(tin),_dey(dey))
                            end;
               write('~');
               write(_name_month(m),_name_day(d));
               textcolor(7);
               if k=1 then writeln('|');
          end;
     end;
     write('+');
     for i:=1 to 38 do write('-');
     write('+');
     for i:=1 to 38 do write('-');
     writeln('+');
     count:=0;
     for i:=0 to 5 do
         if name_month[i]=1 then
            if round(weather[3])-0.5>=lun_month[i] then count:=count+1;
     for i:=6 to num_month do
         if name_month[i]=1 then
            if round(weather[27])-0.5<lun_month[i] then count:=count+1;
     if count=2 then
     begin
          textcolor(14);
          write(_tin(tin),_dey(dey),'~');
          write('Kݶ|');
          writeln('.');
     end
     else
     if count=0 then
     begin
          textcolor(14);
          write(_tin(tin),_dey(dey),'~');
          write('~');
          writeln('.');
     end;
     textcolor(7);
     writeln;
     write('Ы@}, Ϋ ''E'' ѮɡOǮ');
     c:=readkey;
     if c=#0 then c:=readkey;
     if (c='e') or (c='E') then show_weather_et;
end;

{ zऽBA }
procedure kongchi;
var
   i,tin1,dey1:integer;
   JD,maxJD,minJD:extended;
   y,m,d,year1:integer;
   found,leap:boolean;
   c:char;
   me,tin2,dey2:string;

begin
     repeat
           repeat
                 clrscr;
                 write('пJ~ (2637 BC (AD -2636) ΥH, ''ENTER'' ]w~) : ');
                 readln(me);
                 if me='' then year1:=year else val(me,year1,i);
           until year>=-2636;
           repeat
                 clrscr;
                 for i:=0 to 9 do write(i,_tin(i),' ');
                 writeln;
                 write('пJѤz ( ''ENTER'' }) : ');
                 readln(tin2);
                 val(tin2,tin1,i);
                 if tin2<>'' then
                 begin
                      for i:=0 to 11 do write(i,_dey(i),' ');
                      writeln;
                      write('пJa ( ''ENTER'' }) : ');
                      readln(dey2);
                      val(dey2,dey1,i);
                 end;
           until ((tin1>=0) and (tin1<10) and (dey1>=0) and (dey1<12)) or (tin2='') or (dey2='');
           if (tin2<>'') and (dey2<>'') then
           begin
                if not odd(tin1+dey1) then
                begin
                     maxJD:=_JD(year1,12,31);
                     minJD:=_JD(year1,1,1);
                     i:=tin1;
                     while (i mod 12 <> dey1) do i:=i+10;
                     JD:=2449030.5+i;
                     if year1<=1993 then while JD-60>minJD do JD:=JD-60
                        else if year1>1993 then while JD<minJD do JD:=JD+60;
                     textcolor(14);
                     writeln;
                     writeln(' ':9,'                                    A');
                     writeln(' ':9,'P             ~');
                     repeat
                           if year1=year then
                           begin
                                i:=0;
                                found:=false;
                                leap:=false;
                                repeat
                                      if lun_month[i]>JD then
                                      begin
                                           d:=trunc(JD)-trunc(lun_month[i-1])+1;
                                           found:=true;
                                           m:=name_month[i-1];
                                      end;
                                      i:=i+1
                                until found or (i>num_month);
                                leap:=m>100;
                           end;
                           _invJD(JD,yy,mm,dd);
                           textcolor(10);
                           writeln;
                           write('':8,_dayofweek(JD),'    ',dd:2,'   ',mm:2,'   ');
                           if yy<=0 then write(abs(yy-1):4,' BC') else write('AD ',yy:4);
                           write('':7);
                           if year1=year then
                           begin
                                if (m mod 100>=10) and (mm<3) then
                                begin
                                     if leap then textcolor(4) else textcolor(3);
                                     write(_tin(tin-1),_dey(dey-1))
                                end
                                else
                                begin
                                     if leap then textcolor(12) else textcolor(11);
                                     write(_tin(tin),_dey(dey));
                                end;
                                write('~');
                                write(_name_month(m),_name_day(d),'');
                           end
                           else write('':20);
                           writeln(_tin(round(JD-2449030.5) mod 10),_dey(round(JD-2449030.5) mod 12));
                           JD:=JD+60;
                     until JD>maxJD;
                end
                else
                begin
                     textcolor(12);
                     writeln(#7,'zäsb !');
                end;
                writeln;
                textcolor(7);
                write('Ы@~ ( ''ESC'' } )');
                c:=readkey;
                if c=#0 then c:=readkey;
           end
      until (c=#27) or (tin2='') or (dey2='');
end;

procedure showdt(p:extended;j:integer);
var
   h,JD:extended;
   YY,MM,DD:integer;
   hr,min:integer;
   sec:extended;
begin
     _invJD(round(p)-0.5,YY,MM,DD);
     h:=(p-round(p)+0.5)*24.0;
     dms(h,hr,min,sec);
     if YY=year then textcolor(10) else textcolor(2);
     write(DD:2,'/',MM:2,' ',hr:2,':',min:2,' ');
     JD:=_JD(YY,MM,DD);
     if (name_month[j] mod 100>=10) and (j<5) then
        if leap then textcolor(4) else textcolor(3)
     else
     if (name_month[j] mod 100<=3) and (j>10) then
        if leap then textcolor(4) else textcolor(3)
     else
     if leap then textcolor(12) else textcolor(11);
     write(_name_day(round(JD-lun_month[j])+1));
     textcolor(7);
     write('|');
end;

procedure showdtt(p:extended;j:integer);
var
   h,JD:extended;
   YY,MM,DD:integer;
   hr,min,sec00:integer;
   sec:extended;
begin
     _invJD(round(p)-0.5,YY,MM,DD);
     h:=(p-round(p)+0.5)*24.0;
     dms(h,hr,min,sec);
     sec00:=trunc(sec);
     if YY=year then textcolor(10) else textcolor(2);
     write(DD:2,'/',MM:2,'/',YY mod 100:2,' ');
     write(hr:2,':',min:2,':',sec00:2);
     textcolor(7);
     write(' |');
end;

{ܤۤήɶ  Ѯ}
procedure show_phase_et;
var
   c:char;
   leap:boolean;

begin
     clrscr;
     textcolor(14);
     write('':33,'');
     if year<=0 then write('e ',abs(year-1)) else write(' ',year);
     writeln(' ~');
     textcolor(7);
     writeln;
     write('+');
     for i:=1 to 4 do write('------------------+');
     writeln;
     write('|');
     textcolor(14);
     write('':8,'','':8);
     textcolor(7);
     write('|');
     textcolor(14);
     write('':7,'W','':7);
     textcolor(7);
     write('|');
     textcolor(14);
     write('':8,'','':8);
     textcolor(7);
     write('|');
     textcolor(14);
     write('':7,'U','':7);
     textcolor(7);
     writeln('|');
     write('+');
     for i:=1 to 4 do write('------------------+');
     writeln;
     for i:=0 to num_month-2 do
     begin
          textcolor(7);
          write('|');
          showdtt(new_moon_dt[i],i);
          showdtt(q1_moon_dt[i],i);
          showdtt(full_moon_dt[i],i);
          showdtt(q2_moon_dt[i],i);
          writeln;
     end;
     textcolor(7);
     write('+');
     for i:=1 to 4 do write('------------------+');
     writeln;
     textcolor(14);
     writeln(': HWҦܮɶѮɡOǮ');
     textcolor(7);
     writeln;
     write('Ы@}');
     c:=readkey;
     if c=#0 then c:=readkey
end;


{ܤۤήɶ }
procedure show_phase;
var
   YY,MM,DD:integer;
   h,JD:extended;
   hr,min:integer;
   sec:extended;
   c:char;
   leap:boolean;

begin
     clrscr;
     textcolor(14);
     write('':29,'');
     if year<=0 then write('e ',abs(year-1)) else write(' ',year);
     writeln(' ~ (',_tin(tin),_dey(dey),'~)');
     textcolor(7);
     writeln;
     write('+--------+');
     for i:=1 to 4 do write('----------------+');
     writeln;
     write('|');
     textcolor(11);
     write('A');
     textcolor(7);
     write('|');
     textcolor(14);
     write('':7,'','':7);
     textcolor(7);
     write('|');
     textcolor(14);
     write('':6,'W','':6);
     textcolor(7);
     write('|');
     textcolor(14);
     write('':7,'','':7);
     textcolor(7);
     write('|');
     textcolor(14);
     write('':6,'U','':6);
     textcolor(7);
     writeln('|');
     write('+--------+');
     for i:=1 to 4 do write('----------------+');
     writeln;
     for i:=0 to num_month do
     begin
          textcolor(7);
          write('|');
          leap:=(name_month[i]>100);
          if (name_month[i] mod 100>=10) and (i<5) then
             if leap then textcolor(4) else textcolor(3)
          else
          if (name_month[i] mod 100<=3) and (i>10) then
             if leap then textcolor(4) else textcolor(3)
          else
          if leap then textcolor(12) else textcolor(11);
          write(_name_month(name_month[i]));
          textcolor(7);
          write('|');
          showdt(new_moon[i],i);
          showdt(q1_moon[i],i);
          showdt(full_moon[i],i);
          showdt(q2_moon[i],i);
          writeln;
     end;
     textcolor(7);
     write('+--------+');
     for i:=1 to 4 do write('----------------+');
     writeln;
     write('Ы@}, Ϋ ''E'' ѮɡOǮ');
     c:=readkey;
     if c=#0 then c:=readkey;
     if (c='E') or (c='e') then show_phase_et;
end;

{ܸ`}
procedure show_holiday;
var
   i:integer;
   yy,mm,dd:integer;
   x,a,b,c,d,e,f,g,h,k,l,m,n,p:integer;
   w:extended;
   ch:char;
begin
     clrscr;
     textcolor(14);
     writeln(' ',year:4,' ~n`ΰ@');
     writeln;
     textcolor(10);
     write('s~     : ');
     textcolor(7);
     writeln(' 1/ 1/',year:4,' ',_dayofweek(_JD(year,1,1)));
     textcolor(11);
     write('A~@     : ');
     i:=0;
     repeat
           i:=i+1
     until name_month[i]=1;
     _invJD(lun_month[i],yy,mm,dd);
     textcolor(7);
     writeln(dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(lun_month[i]));
     textcolor(11);
     write('A~G     : ');
     _invJD(lun_month[i]+1,yy,mm,dd);
     textcolor(7);
     writeln(dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(lun_month[i]+1));
     textcolor(11);
     write('A~T     : ');
     _invJD(lun_month[i]+2,yy,mm,dd);
     textcolor(7);
     writeln(dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(lun_month[i]+2));
     textcolor(11);
     write('M`         : ');
     textcolor(7);
     _invJD(round(weather[7])-0.5,yy,mm,dd);
     writeln(dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(_JD(yy,mm,dd)));
     x:=year;
     a:=x mod 19;
     b:=x div 100;
     c:=x mod 100;
     d:=b div 4;
     e:=b mod 4;
     f:=(b+8) div 25;
     g:=(b-f+1) div 3;
     h:=(19*a+b-d-g+15) mod 30;
     i:=c div 4;
     k:=c mod 4;
     l:=(32+2*e+2*i-h-k) mod 7;
     m:=(a+11*h+22*l) div 451;
     n:=(h+l-7*m+114) div 31;
     p:=(h+l-7*m+114) mod 31;
     dd:=p+1;
     mm:=n;
     w:=_JD(yy,mm,dd)-2;
     _invJD(w,yy,mm,dd);
     textcolor(10);
     write('Cq     : ');
     textcolor(7);
     writeln(dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(w));
     textcolor(10);
     write('Cqݤ : ');
     _invJD(w+1,yy,mm,dd);
     textcolor(7);
     writeln(dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(w+1));
     textcolor(10);
     write('_`         : ');
     _invJD(w+2,yy,mm,dd);
     textcolor(7);
     writeln(dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(w+2));
     textcolor(10);
     write('_`ݤ     : ');
     _invJD(w+3,yy,mm,dd);
     textcolor(7);
     writeln(dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(w+3));
     if year>=1999 then
     begin
          textcolor(11);
          write('Ұʸ`         : ');
          textcolor(7);
          writeln(' 1/ 5/',yy:4,' ',_dayofweek(_JD(year,5,1)));
     end;
     if year>=1999 then
     begin
          textcolor(11);
          write('           : ');
          i:=0;
          repeat
                i:=i+1
          until name_month[i]=4;
          _invJD(lun_month[i]+7,yy,mm,dd);
          textcolor(7);
          writeln(dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(lun_month[i]+7));
     end;
     textcolor(11);
     write('ݤȸ`         : ');
     i:=0;
     repeat
           i:=i+1
     until name_month[i]=5;
     _invJD(lun_month[i]+4,yy,mm,dd);
     textcolor(7);
     writeln(dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(lun_month[i]+4));
     if (year<1997) and (year>=1952) then
     begin
          textcolor(10);
          write('^kӹب     : ');
          w:=_JD(year,5,31);
          i:=0;
          repeat
                i:=i+1
          until round(w+i+1.5) mod 7 = 6;
          w:=w+i+14;
          _invJD(w,yy,mm,dd);
          textcolor(7);
          writeln(dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(w));
          textcolor(10);
          writeln('^kӹب');
          write('Ĥ@ӬP@   : ');
          _invJD(w+2,yy,mm,dd);
          textcolor(7);
          writeln(dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(w+2));
     end;
     if year=1997 then
     begin
          textcolor(10);
          write('^kӹب     : ');
          w:=_JD(year,6,28);
          _invJD(w,yy,mm,dd);
          textcolor(7);
          writeln(dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(w));
          textcolor(10);
          writeln('^kӹب');
          write('Ĥ@ӬP@   : ');
          _invJD(w+2,yy,mm,dd);
          textcolor(7);
          writeln(dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(w+2));
     end;
     if year>=1997 then
     begin
          textcolor(11);
          write('^k         : ');
          textcolor(7);
          writeln(' 1/ 7/',year:4,' ',_dayofweek(_JD(year,7,1)));
          if year=1997 then
          begin
               textcolor(11);
               write('^kݤ     : ');
               textcolor(7);
               writeln(' 2/ 7/',year:4,' ',_dayofweek(_JD(year,7,2)));
          end;
     end;
     if (year<=1996) and (year>=1946) then
     begin
          textcolor(10);
          writeln('K̫@');
          writeln('ӬP@e');
          write('@ӬP     : ');
          w:=_JD(year,9,1);
          i:=0;
          repeat
                i:=i+1
          until round(w-i+1.5) mod 7 = 1;
          w:=w-i-2;
          _invJD(w,yy,mm,dd);
          textcolor(7);
          writeln(dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(w));
          textcolor(10);
          write('䭫 : ');
          _invJD(w+2,yy,mm,dd);
          textcolor(7);
          writeln(dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(w+2));
     end
     else
     if (year>=1997) and (year<=1998) then
     begin
          textcolor(11);
          write('ܾԳӧQ : ');
          textcolor(7);
          w:=_JD(year,7,31);
          i:=0;
          repeat
                i:=i+1
          until round(w+i+1.5) mod 7 = 1;
          w:=w+i+14;
          _invJD(w,yy,mm,dd);
          textcolor(7);
          writeln(dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(w));
     end;
     textcolor(11);
     write('`         : ');
     i:=0;
     repeat
           i:=i+1
     until name_month[i]=8;
     _invJD(lun_month[i]+14,yy,mm,dd);
     textcolor(7);
     writeln(dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(lun_month[i]+14));
     if year>=1997 then
     begin
          textcolor(11);
          write('y         : ');
          textcolor(7);
          writeln(' 1/10/',year:4,' ',_dayofweek(_JD(year,10,1)));
     end;
     if (year>=1997) and (year<=1998) then
     begin
          textcolor(11);
          write('yݤ     : ');
          textcolor(7);
          writeln(' 2/10/',year:4,' ',_dayofweek(_JD(year,10,2)));
     end;
     textcolor(11);
     write('`         : ');
     i:=0;
     repeat
           i:=i+1
     until name_month[i]=9;
     _invJD(lun_month[i]+8,yy,mm,dd);
     textcolor(7);
     writeln(dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(lun_month[i]+8));
     textcolor(10);
     write('tϸ`         : ');
     textcolor(7);
     writeln('25/12/',year:4,' ',_dayofweek(_JD(year,12,25)));
     textcolor(10);
     write('tϸ`ݤ     : ');
     textcolor(7);
     writeln('26/12/',year:4,' ',_dayofweek(_JD(year,12,26)));
     gotoxy(40,3);
     textcolor(11);
     writeln('ji');
     i:=0;
     repeat
           i:=i+1
     until name_month[i]=1;
     _invJD(lun_month[i]-1,yy,mm,dd);
     gotoxy(40,wherey);
     write('(A~',_name_day(trunc(lun_month[i]-lun_month[i-1])),')   : ');
     textcolor(7);
     writeln(dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(lun_month[i]-1));
     gotoxy(40,wherey);
     textcolor(11);
     write('d`         : ');
     i:=0;
     repeat
           i:=i+1
     until name_month[i]=1;
     _invJD(lun_month[i]+14,yy,mm,dd);
     textcolor(7);
     writeln(dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(lun_month[i]+14));
     gotoxy(40,wherey);
     textcolor(10);
     write('H`         : ');
     textcolor(7);
     writeln('14/ 2/',yy:4,' ',_dayofweek(_JD(year,2,14)));
     gotoxy(40,wherey);
     textcolor(10);
     write('k`         : ');
     textcolor(7);
     writeln(' 8/ 3/',yy:4,' ',_dayofweek(_JD(year,3,8)));
     if year<=1997 then
     begin
          gotoxy(40,wherey);
          textcolor(10);
          write('^p       : ');
          w:=_JD(year,3,1)-1;
          i:=0;
          repeat
                i:=i+1
          until round(w+i+1.5) mod 7 = 1;
          w:=w+i+7;
          _invJD(w,yy,mm,dd);
          textcolor(7);
          writeln(dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(w));
     end;
     gotoxy(40,wherey);
     textcolor(10);
     write('MH`         : ');
     textcolor(7);
     writeln(' 1/ 4/',yy:4,' ',_dayofweek(_JD(year,4,1)));
     gotoxy(40,wherey);
     textcolor(10);
     write('ൣ`         : ');
     textcolor(7);
     writeln(' 4/ 4/',yy:4,' ',_dayofweek(_JD(year,4,4)));
     if (year>=1950) and (year<=1998) then
     begin
          gotoxy(40,wherey);
          textcolor(11);
          write('Ұʸ`         : ');
          textcolor(7);
          writeln(' 1/ 5/',yy:4,' ',_dayofweek(_JD(year,5,1)));
     end;
     gotoxy(40,wherey);
     textcolor(10);
     write('˸`         : ');
     w:=_JD(year,4,30);
     i:=0;
     repeat
           i:=i+1;
     until round(w+i+1.5) mod 7 = 0;
     w:=w+i+7;
     _invJD(w,yy,mm,dd);
     textcolor(7);
     writeln(dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(w));
     if year>=1989 then
     begin
          gotoxy(40,wherey);
          textcolor(12);
          write('|O       : ');
          textcolor(7);
          writeln(' 4/ 6/',yy:4,' ',_dayofweek(_JD(year,6,4)));
     end;
     gotoxy(40,wherey);
     textcolor(10);
     write('˸`         : ');
     w:=_JD(year,5,31);
     i:=0;
     repeat
           i:=i+1;
     until round(w+i+1.5) mod 7 = 0;
     w:=w+i+14;
     _invJD(w,yy,mm,dd);
     textcolor(7);
     writeln(dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(w));
{     gotoxy(40,wherey);
     textcolor(11);
     write('^`   : ');
     i:=0;
     repeat
           i:=i+1
     until name_month[i]=7;
     _invJD(lun_month[i]+6,yy,mm,dd);
     textcolor(7);
     writeln(dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(lun_month[i]+6));}
     gotoxy(40,wherey);
     textcolor(11);
     write('`         : ');
     i:=0;
     repeat
           i:=i+1
     until name_month[i]=7;
     _invJD(lun_month[i]+13,yy,mm,dd);
     textcolor(7);
     writeln(dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(lun_month[i]+13));
     if year>=1999 then
     begin
          gotoxy(40,wherey);
          textcolor(11);
          write('ܾԳӧQ : ');
          textcolor(7);
          w:=_JD(year,7,31);
          i:=0;
          repeat
                i:=i+1
          until round(w+i+1.5) mod 7 = 1;
          w:=w+i+14;
          _invJD(w,yy,mm,dd);
          textcolor(7);
          writeln(dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(w));
     end;
     if year>=1998 then
     begin
          gotoxy(40,wherey);
          textcolor(13);
          write('Юv         : ');
          textcolor(7);
          writeln('10/ 9/',yy:4,' ',_dayofweek(_JD(year,9,10)));
     end;
     if year>=1912 then
     begin
          gotoxy(40,wherey);
          textcolor(11);
          write('Q`         : ');
          textcolor(7);
          writeln('10/10/',yy:4,' ',_dayofweek(_JD(year,10,10)));
     end;
     if year>=1926 then
     begin
          gotoxy(40,wherey);
          textcolor(11);
          write(']s͹ب : ');
          textcolor(7);
          writeln('12/11/',yy:4,' ',_dayofweek(_JD(year,11,12)));
     end;
     gotoxy(40,wherey);
     textcolor(11);
     write('V           : ');
     _invJD(round(weather[24])-0.5,yy,mm,dd);
     textcolor(7);
     writeln(dd:2,'/',mm:2,'/',yy:4,' ',_dayofweek(_JD(yy,mm,dd)));
     gotoxy(40,wherey);
     textcolor(11);
     write('pi         : ');
     textcolor(7);
     writeln('31/12/',yy:4,' ',_dayofweek(_JD(year,12,31)));
     writeln;
     gotoxy(59,24);
     textcolor(14);
     write('Ы@}...');
     textcolor(7);
     ch:=readkey;
     if ch=#0 then ch:=readkey
end;

{ X }
procedure outdata;
var
   me:string;
   f:text;
   found,leap,kc:boolean;
   y,m,mm,d:integer;
   hr,min,sec00:integer;
   sec,w:extended;
   i,j:integer;
   tin,dey:integer;
   JD,startJD:extended;
   c:char;

begin
     clrscr;
     writeln('пܮɶt: (H)   ɶ, ϥδq榡 (UT + 8)');
     writeln('                (J)   OǮ/Ѯ, ϥξ榡 (TD/ET)');
     writeln('                (D)   OǮ/Ѯ, ϥδq榡 (TD/ET)');
     write('AܬO ( ''ESC'' }) : ');
     repeat
           q1:=readkey;
           if q1=#0 then q1:=readkey
     until (q1='H') or (q1='h') or (q1='J') or (q1='j') or (q1='D') or (q1='d') or (q1=#27);
     writeln(q1);
     if q1<>#27 then
     begin
          write('O_䤤CXz(y/N, ''ESC'' }) ?');
          c:=readkey;
          if c=#0 then c:=readkey;
          if c<>#27 then
          begin
               kc:=(c='y') or (c='Y');
               writeln(c);
               write('пJɮצWr(s|): ');
               readln(me);
               assign(f,me);
               rewrite(f);
               if (q1='J') or (q1='j') then
               begin
                    { X }
                    write(f,year,'  ');
                    if year<=1582 then
                       if year mod 4=0 then writeln(f,366)
                          else writeln(f,365)
                       else if (year mod 4=0) and (year mod 100<>0) then writeln(f,366)
                            else if year mod 400=0 then writeln(f,366)
                    else writeln(f,365);
                    tin:=(year-1984) mod 10;
                    if tin<0 then tin:=tin+10;
                    if tin>10 then tin:=tin-10;
                    dey:=(year-1984) mod 12;
                    if dey<0 then dey:=dey+12;
                    if dey>12 then dey:=dey-12;
                    writeln(f,tin:2,'  ',dey:2,'  ',name_leap,'  ',total_year);
                    writeln(f);
                    for i:=0 to num_month do writeln(f,name_month[i]:3,'  ',lun_month[i],'  ',no_day[i]);
                    writeln(f);
                    { X۸ }
                    for i:=0 to num_month do
                    begin
                         writeln(f,name_month[i]:3,'  ',new_moon_dt[i],'  ',q1_moon_dt[i]);
                         writeln(f,'':5,full_moon_dt[i],'  ',q2_moon_dt[i]);
                    end;
                    writeln(f);
                    { Xܥ|` }
                    for i:=1 to 28 do writeln(f,i:2,'  ',weather_dt[i mod 24]);
               end;
               if (q1='H') or (q1='h') then
               begin
                    { X }
                    if year>0 then write(f,' ',year:5,' ~')
                       else write(f,'e ',abs(year-1):4,' ~');
                    if year<=1582 then
                       if year mod 4=0 then writeln(f,' (|~) @ 366 .')
                          else writeln(f,' (~) @ 365 .')
                       else if (year mod 4=0) and (year mod 100<>0) then writeln(f,' (|~) @ 366 .')
                            else if year mod 400=0 then writeln(f,' (|~) @ 366 .')
                    else writeln(f,' (~) @ 365 .');
                    tin:=(year-1984) mod 10;
                    dey:=(year-1984) mod 12;
                    write(f,'A ',_tin(tin),_dey(dey),' ~');
                    if total_year>360 then write(f,' (',_name_month(name_leap+100),')') else write(f,' (~)');
                    writeln(f,' @ ',total_year,' .');
                    writeln(f);
                    for i:=0 to num_month do
                    begin
                         if (i<4) and (name_month[i]>9) then write(f,_tin(tin-1),_dey(dey-1))
                            else if (name_month[i]<4) and (i>9) then write(f,_tin(tin+1),_dey(dey+1))
                                 else write(f,_tin(tin),_dey(dey));
                         write(f,'~');
                         _invJD(lun_month[i],y,m,d);
                         write(f,_name_month(name_month[i]));
                         if no_day[i]=29 then write(f,'p')
                            else write(f,'j');
                         writeln(f,'  ',d:2,'/',m:2,'/',y:4);
                    end;
                    writeln(f);
                    { X۸ }
                    for i:=0 to num_month do
                    begin
                         if (i<4) and (name_month[i]>9) then write(f,_tin(tin-1),_dey(dey-1))
                            else if (name_month[i]<4) and (i>9) then write(f,_tin(tin+1),_dey(dey+1))
                                 else write(f,_tin(tin),_dey(dey));
                         write(f,'~');
                         w:=round(new_moon[i])-0.5;
                         _invJD(w,y,m,d);
                         dms((new_moon[i]-w)*24,hr,min,sec);
                         write(f,_name_month(name_month[i]),' ',_name_day(round(w-lun_month[i]+1)));
                         writeln(f,'  : ',d:2,'/',m:2,'/',y:4,'  ',hr:2,':',min:2,' HKT');
                         w:=round(q1_moon[i])-0.5;
                         _invJD(w,y,m,d);
                         dms((q1_moon[i]-w)*24,hr,min,sec);
                         write(f,'':15,_name_day(round(w-lun_month[i]+1)),'W: ');
                         writeln(f,d:2,'/',m:2,'/',y:4,'  ',hr:2,':',min:2,' HKT');
                         w:=round(full_moon[i])-0.5;
                         _invJD(w,y,m,d);
                         dms((full_moon[i]-w)*24,hr,min,sec);
                         write(f,'':15,_name_day(round(w-lun_month[i]+1)),'  : ');
                         writeln(f,d:2,'/',m:2,'/',y:4,'  ',hr:2,':',min:2,' HKT');
                         w:=round(q2_moon[i])-0.5;
                         _invJD(w,y,m,d);
                         dms((q2_moon[i]-w)*24,hr,min,sec);
                         write(f,'':15,_name_day(round(w-lun_month[i]+1)),'U: ');
                         writeln(f,d:2,'/',m:2,'/',y:4,'  ',hr:2,':',min:2,' HKT');
                    end;
                    writeln(f);
                    { Xܥ|` }
                    for i:=1 to 28 do
                    begin
                         w:=round(weather[i])-0.5;
                         _invJD(w,y,m,d);
                         dms((weather[i]-w)*24,hr,min,sec);
                         write(f,_name_weather(i),'  ',d:2,'/',m:2,'/',y:4,'  ',hr:2,':',min:2,' HKT  ');
                         j:=-1;
                         repeat
                               j:=j+1;
                         until w<lun_month[j];
                         if (j-1<4) and (name_month[j-1]>9) then write(f,_tin(tin-1),_dey(dey-1))
                            else if (name_month[j-1]<4) and (j-1>9) then write(f,_tin(tin+1),_dey(dey+1))
                                 else write(f,_tin(tin),_dey(dey));
                         write(f,'~');
                         writeln(f,_name_month(name_month[j-1]),_name_day(round(w-lun_month[j-1]+1)),'');
                    end;
               end;
               if (q1='D') or (q1='d') then
               begin
                    { X }
                    if year>0 then write(f,' ',year:5,' ~')
                       else write(f,'e ',abs(year-1):4,' ~');
                    if year<=1582 then
                       if year mod 4=0 then writeln(f,' (|~) @ 366 .')
                          else writeln(f,' (~) @ 365 .')
                       else if (year mod 4=0) and (year mod 100<>0) then writeln(f,' (|~) @ 366 .')
                            else if year mod 400=0 then writeln(f,' (|~) @ 366 .')
                    else writeln(f,' (~) @ 365 .');
                    tin:=(year-1984) mod 10;
                    dey:=(year-1984) mod 12;
                    write(f,'A ',_tin(tin),_dey(dey),' ~');
                    if total_year>360 then write(f,' (',_name_month(name_leap+100),')') else write(f,' (~)');
                    writeln(f,' @ ',total_year,' .');
                    writeln(f);
                    for i:=0 to num_month do
                    begin
                         if (i<4) and (name_month[i]>9) then write(f,_tin(tin-1),_dey(dey-1))
                            else if (name_month[i]<4) and (i>9) then write(f,_tin(tin+1),_dey(dey+1))
                                 else write(f,_tin(tin),_dey(dey));
                         write(f,'~');
                         _invJD(lun_month[i],y,m,d);
                         write(f,_name_month(name_month[i]));
                         if no_day[i]=29 then write(f,'p')
                            else write(f,'j');
                         writeln(f,'  ',d:2,'/',m:2,'/',y:4);
                    end;
                    writeln(f);
                    { X۸ }
                    for i:=0 to num_month do
                    begin
                         w:=round(new_moon_dt[i])-0.5;
                         _invJD(w,y,m,d);
                         dms((new_moon_dt[i]-w)*24,hr,min,sec);
                         sec00:=trunc(sec);
                         writeln(f,'  : ',d:2,'/',m:2,'/',y:4,'  ',hr:2,':',min:2,':',sec00:2,' TDT/ET');
                         w:=round(q1_moon_dt[i])-0.5;
                         _invJD(w,y,m,d);
                         dms((q1_moon_dt[i]-w)*24,hr,min,sec);
                         sec00:=trunc(sec);
                         write(f,'W: ');
                         writeln(f,d:2,'/',m:2,'/',y:4,'  ',hr:2,':',min:2,':',sec00:2,' TDT/ET');
                         w:=round(full_moon_dt[i])-0.5;
                         _invJD(w,y,m,d);
                         dms((full_moon_dt[i]-w)*24,hr,min,sec);
                         sec00:=trunc(sec);
                         write(f,'  : ');
                         writeln(f,d:2,'/',m:2,'/',y:4,'  ',hr:2,':',min:2,':',sec00:2,' TDT/ET');
                         w:=round(q2_moon_dt[i])-0.5;
                         _invJD(w,y,m,d);
                         dms((q2_moon_dt[i]-w)*24,hr,min,sec);
                         sec00:=trunc(sec);
                         write(f,'U: ');
                         writeln(f,d:2,'/',m:2,'/',y:4,'  ',hr:2,':',min:2,':',sec00:2,' TDT/ET');
                         writeln(f);
                    end;
                    writeln(f);
                    { Xܥ|` }
                    for i:=1 to 28 do
                    begin
                         w:=round(weather_dt[i])-0.5;
                         _invJD(w,y,m,d);
                         dms((weather_dt[i]-w)*24,hr,min,sec);
                         sec00:=trunc(sec);
                         writeln(f,_name_weather(i),'  ',d:2,'/',m:2,'/',y:4,'  ',hr:2,':',min:2,':',sec00:2,' TDT/ET');
                    end;
               end;
               { X~ }
               for mm:=1 to 12 do
               begin
                    printmonth(f,mm,kc);
               end;
               close(f);
          end;
     end;
end;

{ Main Block Start Here }
begin
     jump:=false;
     getdate(year0,k1,k1,k1);
     repeat
           repeat
                 clrscr;
                 textcolor(11);
                 writeln('AΤഫ{ ( ',ver,' )');
                 textcolor(10);
                 writeln('@: F, ',date);
                 textcolor(7);
                 writeln('ѤƾǦӷ: ');
                 highvideo;
                 writeln('Jean Meeus: Astronomical Algorithms, Willmann-Bell Inc., 1991');
                 writeln('Supplement to the Astronomical Almanac for 1984, USNO');
                 writeln('Jeffrey Sax: Astronomical Algorithms Software Toolbox, Willmann-Bell Inc., 1991');
                 writeln;
                 textcolor(12);
                 writeln('ԥH{eڪǥ.');
                 textcolor(14);
                 writeln;
                 writeln('{ue 104 ~ (AD -103)   11000 ~');
                 write('пJ~ (u ''ENTER'' tΦ~, J ''Q'' ) : ');
                 if not jump then
                 begin
                      readln(year1);
                      if year1='' then year:=year0
                      else Val(year1,year,i);
                 end
                 else writeln(year);
           until ((year>=-103) and (year<=11000)) or (year1='') or (year1='q') or (year1='Q');
           if (year1='q') or (year1='Q') then halt;
           textcolor(13);
           writeln;
           write('');
           if year<=0 then write('e ',abs(year-1):2) else write(' ',year:4);
           writeln(' ~');
           jump:=false;
           textcolor(9);
           writeln('si椤, еy...');
           writeln('pAQb~X, Ы@.');
           create(year-1,0,perihelion,aphelion,i,0);
           create(year,1,perihelion,aphelion,name_leap,i);
           textcolor(7);
           repeat
                 clrscr;
                 textcolor(11);
                 writeln('AΤഫ{ ( ',ver,' )');
                 textcolor(10);
                 writeln('@: F, ',date);
                 textcolor(7);
                 write('+');
                 for i:=1 to 37 do write('-');
                 write('+');
                 for i:=1 to 39 do write('-');
                 writeln('+');
                 for i:=0 to num_month do
                 begin
                      write('|','':37,'| ');
                      _invJD(lun_month[i],yy,mm,dd);
                      if name_month[i]>100 then leap:=true else leap:=false;
                      if ((i<5) and (name_month[i] mod 100>=10)) or ((i>10) and (name_month[i] mod 100<5)) then
                         if not leap then textcolor(3) else textcolor(4)
                      else
                      if leap then textcolor(12) else textcolor(11);
                      write(_name_month(name_month[i]));
                      if no_day[i]=29 then write('p') else write('j');
                      write(' @');
                      textcolor(7);
                      write(': ');
                      if yy<>year then textcolor(2) else textcolor(10);
                      write(dd:2,'/',mm:2,'/',yy:5,' ',_dayofweek(lun_month[i]));
                      textcolor(7);
                      writeln(' |');
                 end;
                 textcolor(7);
                 for j:=1 to 2 do writeln('|','':37,'|','':39,'|');
                 write('+');
                 for i:=1 to 37 do write('-');
                 write('+');
                 for i:=1 to 39 do write('-');
                 writeln('+');
                 gotoxy(1,4);
                 textcolor(7);
                 write('| ');
                 textcolor(10);
                 write('');
                 if year<=0 then write('e ');
                 textcolor(10);
                 if year<=0 then write(abs(year-1):2) else write(' ',year:4);
                 write(' ~ ');
                 if year mod 4<>0 then writeln('(~) @ 365 .')
                   else if (year mod 400<>0) and (year mod 100=0) and (year>1582) then writeln('(~) @ 365 .')
                        else
                        begin
                             textcolor(13);
                             write('(|~)');
                             textcolor(10);
                             writeln(' @ 366 .');
                        end;
                 tin:=(year-1984) mod 10;
                 dey:=(year-1984) mod 12;
                 textcolor(7);
                 write('| ');
                 textcolor(11);
                 write('A ',_tin(tin),_dey(dey),' ~ ');
                 if total_year<360 then write('(~)') else
                 begin
                      textcolor(12);
                      write('(|~)');
                      textcolor(11);
                 end;
                 writeln(' @ ',total_year,' .');
                 textcolor(7);
                 _invJD(perihelion,yy,mm,dd);
                 write('| LI:',dd:2,'/',mm:2,'':4);
                 _invJD(aphelion,yy,mm,dd);
                 writeln('LI:',dd:2,'/',mm:2);
                 dms(dT(_JD(year,7,1))*24,h,m,s);
                 if year>=1984 then write('| TDT') else write('| ET');
                 writeln(' - UTC = ',h:2,'  ',m:2,'  ',s:2:1,' ');
                 writeln('| 1   : Aऽ');
                 writeln('| 2   : A');
                 writeln('| 3   : zऽ(ιA)');
                 writeln('| 4   : z~ऽ~');
                 writeln('| 5   : ~z~');
                 writeln('| 6   : ܤ@Ӥ');
                 writeln('| 7   : ܤ@ӹA');
                 writeln('| 8   : ܤܥ|`ήɶ');
                 writeln('| 9   : ܮҡBΤWUήɶ');
                 if year>=1843 then writeln('| H   : ܬO~n`Τ');
                 writeln('| 0   : ܤ~');
                 writeln('| +/- : N~W@~');
                 if year<=1842 then writeln('| P   : XO~Ҧ')
                    else writeln ('| P   : XO~Ҧ(`~)');
                 gotoxy(1,num_month+6);
                 write('| ');
                 textcolor(14);
                 write('AܬO (''ESC'' }) : ');
                 textcolor(7);
                 q1:=readkey;
                 if q1=#0 then q1:=readkey;
                 case q1 of
                      '1':      ltos;
                      '2':      stol;
                      '3':      kongchi;
                      '4':      tindeyto;
                      '5':      totindey;
                      '6':      outmonth;
                      '7':      outlunmonth;
                      '8':      show_weather;
                      '9':      show_phase;
                      'H','h':  if year>=1843 then show_holiday;
                      'p','P':  begin
                                     outdata;
                                     q1:='9'
                                end;
                      '+',#81:  if year<11000 then
                                begin
                                     jump:=true;
                                     year:=year+1;
                                end;
                      '-',#73:  if year>-104 then
                                begin
                                     year:=year-1;
                                     jump:=true
                                end;
                 end;
           until (q1='0') or ((q1>'9') and (q1<>'H') and (q1<>'h')) or (q1=#27) or (q1=#13) or (jump=true);
     until (q1=#27) or (q1=#13);
     textcolor(7);
     writeln;
     writeln;
end.
