unit Unit4;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Spin;

type
  Tstol = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    new_weekday: TLabel;
    lun_year: TLabel;
    lun_month_label1: TLabel;
    lun_day: TLabel;
    lun_kc: TLabel;
    convert: TButton;
    quit: TButton;
    Label8: TLabel;
    new_year: TLabel;
    new_month: TEdit;
    new_day: TEdit;
    defaultdate: TButton;
    Label9: TLabel;
    Label10: TLabel;
    addmonth: TButton;
    minusmonth: TButton;
    addday: TButton;
    minusday: TButton;
    procedure quitClick(Sender: TObject);
    procedure convertClick(Sender: TObject);
    procedure defaultdateClick(Sender: TObject);
    procedure currentyear(Sender: TObject);
    procedure addmonthClick(Sender: TObject);
    procedure minusmonthClick(Sender: TObject);
    procedure adddayClick(Sender: TObject);
    procedure minusdayClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  stol: Tstol;

implementation

{$R *.DFM}

uses unit16,day;

procedure Tstol.quitClick(Sender: TObject);
begin
     stol.hide;
end;

procedure Tstol.convertClick(Sender: TObject);
var
   max_sday,mm,m,dd,d,i:integer;
   JD:extended;
   found,leap:boolean;
   s:string;
begin
     mm:=_val1(stol.new_month.text);
     dd:=_val1(stol.new_day.text);
     case mm of
          1,3,5,7,8,10,12: max_sday:=31;
          4,6,9,11: max_sday:=30;
          2: if year_default mod 4<>0 then max_sday:=28
             else if (year_default mod 400<>0) and (year_default mod 100=0) and (year_default>1582) then max_sday:=28
                  else max_sday:=29;
          else max_sday:=-1;
     end;
     found:=false;
     if (max_sday<>-1) and ((dd<=max_sday) and (dd>0)) then
     if not ((year_default=1582) and (mm=10) and (dd>4) and (dd<15)) then
     begin
          JD:=_JD(year_default,mm,dd);
          i:=0;
          leap:=false;
          repeat
                if lun_month[i]>JD then
                begin
                     d:=trunc(JD)-trunc(lun_month[i-1])+1;
                     found:=true;
                     m:=name_month[i-1];
                end;
                i:=i+1
          until found or (i>num_month);
          if found then
          begin
               if (m mod 100>=10) and (mm<3) then
               begin
                    stol.lun_year.caption:=_tin(tin_default-1)+_dey(dey_default-1)+'~'
               end
               else
               begin
                    stol.lun_year.caption:=_tin(tin_default)+_dey(dey_default)+'~';
               end;
               stol.lun_month_label1.caption:=_name_month(m);
               if m>100 then
                  stol.lun_month_label1.font.color:=clred
               else
                  stol.lun_month_label1.font.color:=claqua;
               stol.lun_day.caption:=_name_day(d)+'';
               stol.lun_kc.caption:=_tin(round(JD-2449030.5) mod 10)+_dey(round(JD-2449030.5) mod 12);
               stol.new_weekday.caption:=_dayofweek(JD);
          end;
     end;
     if not found then
     begin
          s:='sb';
          stol.lun_year.caption:=s;
          stol.lun_month_label1.caption:=s;
          stol.lun_day.caption:=s;
          stol.lun_kc.caption:=s;
          stol.new_weekday.caption:=s;
          wrong.messages.caption:='äsb!';
          wrong.show;
          MessageBeep(MB_ICONEXCLAMATION)
     end;
end;

procedure Tstol.defaultdateClick(Sender: TObject);
var
   y,m,d:word;
begin
     decodedate(date,y,m,d);
     stol.new_month.text:=_str1(m);
     stol.new_day.text:=_str1(d);
end;

procedure Tstol.currentyear(Sender: TObject);
var
   y,m,d:word;
   s:string;
begin
     decodedate(date,y,m,d);
     if y=year_default then stol.defaultdate.enabled:=true
        else stol.defaultdate.enabled:=false;
     if y<=0 then stol.new_year.caption:='e '+_str1(abs(year_default-1))+' ~'
        else stol.new_year.caption:=' '+_str1(year_default)+' ~';
end;

procedure Tstol.addmonthClick(Sender: TObject);
var
   s:integer;
begin
     s:=_val1(new_month.text);
     s:=s+1;
     if s=13 then s:=1;
     new_month.text:=_str1(s);
end;

procedure Tstol.minusmonthClick(Sender: TObject);
var
   s:integer;
begin
     s:=_val1(new_month.text);
     s:=s-1;
     if s=0 then s:=12;
     new_month.text:=_str1(s);
end;

procedure Tstol.adddayClick(Sender: TObject);
var
   s:integer;
begin
     s:=_val1(new_day.text);
     s:=s+1;
     if s=32 then s:=1;
     new_day.text:=_str1(s);
end;


procedure Tstol.minusdayClick(Sender: TObject);
var
   s:integer;
begin
     s:=_val1(new_day.text);
     s:=s-1;
     if s=0 then s:=31;
     new_day.text:=_str1(s);
end;

end.
